--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

PACKAGE registerpkg IS

	COMPONENT reg
	PORT(D: IN BIT;
	     EN: IN BIT;
	     CLK: IN BIT;
	     R: IN BIT;
	     Q: OUT BIT);
	END COMPONENT;

	COMPONENT reg4
	PORT(D3, D2, D1, D0: IN BIT;
	     EN: IN BIT;
	     CLK: IN BIT;
	     R: IN BIT;
	     Q3, Q2, Q1, Q0: OUT BIT);
	END COMPONENT;

	COMPONENT reg8
	PORT(D7,D6,D5,D4,D3,D2,D1,D0: IN BIT;
	     EN: IN BIT;
	     CLK: IN BIT;
	     R: IN BIT;
	     Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0: OUT BIT);
	END COMPONENT;

	COMPONENT reg16
	PORT(
	     D15,D14,D13,D12,D11,D10,D9,D8: IN BIT;
	     D7,D6,D5,D4,D3,D2,D1,D0: IN BIT;
	     EN: IN BIT;
	     CLK: IN BIT;
	     R: IN BIT;
	     Q15,Q14,Q13,Q12,Q11,Q10,Q9,Q8: OUT BIT;
	     Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0: OUT BIT);
	END COMPONENT;
END registerpkg;

ENTITY reg IS
	PORT(
	     D: IN BIT;
	     EN: IN BIT;
	     CLK: IN BIT;
	     R: IN BIT;
	     Q: OUT BIT
	);

END reg;

ARCHITECTURE archREG of reg IS
	signal di: bit;
	signal qtmp: bit;
component dsrff
    port(
	d	: in bit;		-- D input to register.
	s	: in bit;		-- Set input Async.
	r	: in bit;		-- Reset input Async.
	clk	: in bit;		-- Positive edge Clock.
	q	: out bit		-- Output from register.
    );
end component;
BEGIN
    di <= (d and en) or (not(en) and qtmp);
    d:dsrff port map(di,zero,r,clk,qtmp);
    q <= qtmp;
END archREG;

ENTITY reg4 IS
    PORT(D3, D2, D1, D0: IN BIT;
	 EN: IN BIT;
	 CLK: IN BIT;
	 R: IN BIT;
	 Q3, Q2, Q1, Q0: OUT BIT);

END reg4;

ARCHITECTURE archREG4 of reg4 IS
BEGIN

	r1:reg port map(D0,en,clk,r,q0);
	r2:reg port map(D1,en,clk,r,q1);
	r3:reg port map(D2,en,clk,r,q2);
	r4:reg port map(D3,en,clk,r,q3);

END archREG4;

ENTITY reg8 IS
    PORT(D7,D6,D5,D4,D3,D2,D1,D0: IN BIT;
	 EN: IN BIT;
	 CLK: IN BIT;
	 R: IN BIT;
	 Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0: OUT BIT);
END reg8;

ARCHITECTURE archREG8 of reg8 IS
BEGIN

	r1:reg4 port map( d3, d2, d1, d0,en,clk,r, q3, q2, q1, q0);
	r2:reg4 port map( d7, d6, d5, d4,en,clk,r, q7, q6, q5, q4);

END archREG8;

ENTITY reg16 IS
    PORT(D15,D14,D13,D12,D11,D10,D9,D8: IN BIT;
	 D7,D6,D5,D4,D3,D2,D1,D0: IN BIT;
	 EN: IN BIT;
	 CLK: IN BIT;
	 R: IN BIT;
	 Q15,Q14,Q13,Q12,Q11,Q10,Q9,Q8: OUT BIT;
	 Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0: OUT BIT);
END reg16;

ARCHITECTURE archREG16 of reg16 IS
BEGIN

	r1:reg4 port map( d3, d2, d1, d0,en,clk,r, q3, q2, q1, q0);
	r2:reg4 port map( d7, d6, d5, d4,en,clk,r, q7, q6, q5, q4);
	r3:reg4 port map(d11,d10, d9, d8,en,clk,r,q11,q10, q9, q8);
	r4:reg4 port map(d15,d14,d13,d12,en,clk,r,q15,q14,q13,q12);

END archREG16;
