--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

PACKAGE iopkg IS

    COMPONENT CKPAD
	PORT ( 
	    p		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT HDPAD
	PORT (
	    p		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT HDIPAD
	PORT (
	    p		: IN BIT;
	    qn		: OUT BIT);
    END COMPONENT;

    COMPONENT HD2PAD
	PORT (
	    p0		: IN BIT;
	    p1		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT HD3PAD
	PORT (
	    p0		: IN BIT;
	    p1		: IN BIT;
	    p2		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT HD4PAD
	PORT (
	    p0		: IN BIT;
	    p1		: IN BIT;
	    p2		: IN BIT;
	    p3		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT INPAD
	PORT ( 
	    p		: INOUT x01z;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT OUTPAD
	PORT ( 
	    a		: IN BIT;
	    p		: INOUT x01z);
    END COMPONENT;

    component bufoe2
	port(x1, x0, oe	: in	bit;
	     y1, y0	: inout	x01z;
	     yfb1, yfb0	: out	bit);
    end component;

    component bufoe3
	port(x2,x1,x0,oe	: in	bit;
	     y2,y1,y0		: inout	x01z;
	     yfb2,yfb1,yfb0	: out	bit);
    end component;

    component bufoe4
	port(x3,x2,x1,x0,oe		: in	bit;
	     y3,y2,y1,y0		: inout	x01z;
	     yfb3,yfb2,yfb1,yfb0	: out	bit);
    end component;

    component bufoe6
	port(x5,x4,x3,x2,x1,x0,oe		: in	bit;
	     y5,y4,y3,y2,y1,y0			: inout	x01z;
	     yfb5,yfb4,yfb3,yfb2,yfb1,yfb0	: out	bit);
    end component;

    component bufoe8
	port(x7,x6,x5,x4		: in	bit;
	     x3,x2,x1,x0,oe		: in	bit;
	     y7,y6,y5,y4		: inout	x01z;
	     y3,y2,y1,y0		: inout	x01z;
	     yfb7,yfb6,yfb5,yfb4	: out	bit;
	     yfb3,yfb2,yfb1,yfb0	: out	bit);
    end component;

    component bufoe12
	port(x11,x10,x9,x8		: in	bit;
	     x7,x6,x5,x4		: in	bit;
	     x3,x2,x1,x0,oe		: in	bit;
	     y11,y10,y9,y8		: inout	x01z;
	     y7,y6,y5,y4		: inout	x01z;
	     y3,y2,y1,y0		: inout	x01z;
	     yfb11,yfb10,yfb9,yfb8	: out	bit;
	     yfb7,yfb6,yfb5,yfb4	: out	bit;
	     yfb3,yfb2,yfb1,yfb0	: out	bit);
    end component;

    component bufoe16
	port(x15,x14,x13,x12		: in	bit;
	     x11,x10,x9,x8		: in	bit;
	     x7,x6,x5,x4		: in	bit;
	     x3,x2,x1,x0,oe		: in	bit;
	     y15,y14,y13,y12		: inout	x01z;
	     y11,y10,y9,y8		: inout	x01z;
	     y7,y6,y5,y4		: inout	x01z;
	     y3,y2,y1,y0		: inout	x01z;
	     yfb15,yfb14,yfb13,yfb12	: out	bit;
	     yfb11,yfb10,yfb9,yfb8	: out	bit;
	     yfb7,yfb6,yfb5,yfb4	: out	bit;
	     yfb3,yfb2,yfb1,yfb0	: out	bit);
    end component;

    component bufoe24
	port(x23,x22,x21,x20		: in	bit;
	     x19,x18,x17,x16		: in	bit;
	     x15,x14,x13,x12		: in	bit;
	     x11,x10,x9,x8		: in	bit;
	     x7,x6,x5,x4		: in	bit;
	     x3,x2,x1,x0,oe		: in	bit;
	     y23,y22,y21,y20		: inout	x01z;
	     y19,y18,y17,y16		: inout	x01z;
	     y15,y14,y13,y12		: inout	x01z;
	     y11,y10,y9,y8		: inout	x01z;
	     y7,y6,y5,y4		: inout	x01z;
	     y3,y2,y1,y0		: inout	x01z;
	     yfb23,yfb22,yfb21,yfb20	: out	bit;
	     yfb19,yfb18,yfb17,yfb16	: out	bit;
	     yfb15,yfb14,yfb13,yfb12	: out	bit;
	     yfb11,yfb10,yfb9,yfb8	: out	bit;
	     yfb7,yfb6,yfb5,yfb4	: out	bit;
	     yfb3,yfb2,yfb1,yfb0	: out	bit);
    end component;

    component bufoe32
	port(x31,x30,x29,x28		: in	bit;
	     x27,x26,x25,x24		: in	bit;
	     x23,x22,x21,x20		: in	bit;
	     x19,x18,x17,x16		: in	bit;
	     x15,x14,x13,x12		: in	bit;
	     x11,x10,x9,x8		: in	bit;
	     x7,x6,x5,x4		: in	bit;
	     x3,x2,x1,x0,oe		: in	bit;
	     y31,y30,y29,y28		: inout	x01z;
	     y27,y26,y25,y24		: inout	x01z;
	     y23,y22,y21,y20		: inout	x01z;
	     y19,y18,y17,y16		: inout	x01z;
	     y15,y14,y13,y12		: inout	x01z;
	     y11,y10,y9,y8		: inout	x01z;
	     y7,y6,y5,y4		: inout	x01z;
	     y3,y2,y1,y0		: inout	x01z;
	     yfb31,yfb30,yfb29,yfb28	: out	bit;
	     yfb27,yfb26,yfb25,yfb24	: out	bit;
	     yfb23,yfb22,yfb21,yfb20	: out	bit;
	     yfb19,yfb18,yfb17,yfb16	: out	bit;
	     yfb15,yfb14,yfb13,yfb12	: out	bit;
	     yfb11,yfb10,yfb9,yfb8	: out	bit;
	     yfb7,yfb6,yfb5,yfb4	: out	bit;
	     yfb3,yfb2,yfb1,yfb0	: out	bit);
    end component;

    component triout2
	port(x1, x0, oe		: in	bit;
	     y1, y0		: out	x01z);
    end component;

    component triout3
	port(x2,x1,x0,oe	: in	bit;
	     y2,y1,y0		: out	x01z);
    end component;

    component triout4
	port(x3,x2,x1,x0,oe	: in	bit;
	     y3,y2,y1,y0	: out	x01z);
    end component;

    component triout6
	port(x5,x4,x3,x2,x1,x0,oe  : in	bit;
	     y5,y4,y3,y2,y1,y0	: out	x01z);
    end component;

    component triout8
	port(x7,x6,x5,x4	: in	bit;
	     x3,x2,x1,x0,oe	: in	bit;
	     y7,y6,y5,y4	: out	x01z;
	     y3,y2,y1,y0	: out	x01z);
    end component;

    component triout12
	port(x11,x10,x9,x8	: in	bit;
	     x7,x6,x5,x4	: in	bit;
	     x3,x2,x1,x0,oe	: in	bit;
	     y11,y10,y9,y8	: out	x01z;
	     y7,y6,y5,y4	: out	x01z;
	     y3,y2,y1,y0	: out	x01z);
    end component;

    component triout16
	port(x15,x14,x13,x12	: in	bit;
	     x11,x10,x9,x8	: in	bit;
	     x7,x6,x5,x4	: in	bit;
	     x3,x2,x1,x0,oe	: in	bit;
	     y15,y14,y13,y12	: out	x01z;
	     y11,y10,y9,y8	: out	x01z;
	     y7,y6,y5,y4	: out	x01z;
	     y3,y2,y1,y0	: out	x01z);
    end component;

    component triout24
	port(x23,x22,x21,x20	: in	bit;
	     x19,x18,x17,x16	: in	bit;
	     x15,x14,x13,x12	: in	bit;
	     x11,x10,x9,x8	: in	bit;
	     x7,x6,x5,x4	: in	bit;
	     x3,x2,x1,x0,oe	: in	bit;
	     y23,y22,y21,y20	: out	x01z;
	     y19,y18,y17,y16	: out	x01z;
	     y15,y14,y13,y12	: out	x01z;
	     y11,y10,y9,y8	: out	x01z;
	     y7,y6,y5,y4	: out	x01z;
	     y3,y2,y1,y0	: out	x01z);
    end component;

    component triout32
	port(x31,x30,x29,x28	: in	bit;
	     x27,x26,x25,x24	: in	bit;
	     x23,x22,x21,x20	: in	bit;
	     x19,x18,x17,x16	: in	bit;
	     x15,x14,x13,x12	: in	bit;
	     x11,x10,x9,x8	: in	bit;
	     x7,x6,x5,x4	: in	bit;
	     x3,x2,x1,x0,oe	: in	bit;
	     y31,y30,y29,y28	: out	x01z;
	     y27,y26,y25,y24	: out	x01z;
	     y23,y22,y21,y20	: out	x01z;
	     y19,y18,y17,y16	: out	x01z;
	     y15,y14,y13,y12	: out	x01z;
	     y11,y10,y9,y8	: out	x01z;
	     y7,y6,y5,y4	: out	x01z;
	     y3,y2,y1,y0	: out	x01z);
    end component;

    component gnd2
	port(x1, x0		: out	bit);
    end component;

    component gnd3
	port(x2,x1,x0		: out	bit);
    end component;

    component gnd4
	port(x3,x2,x1,x0	: out	bit);
    end component;

    component gnd6
	port(x5,x4,x3,x2,x1,x0	: out	bit);
    end component;

    component gnd8
	port(x7,x6,x5,x4	: out	bit;
	     x3,x2,x1,x0	: out	bit);
    end component;

    component gnd12
	port(x11,x10,x9,x8	: out	bit;
	     x7,x6,x5,x4	: out	bit;
	     x3,x2,x1,x0	: out	bit);
    end component;

    component gnd16
	port(x15,x14,x13,x12	: out	bit;
	     x11,x10,x9,x8	: out	bit;
	     x7,x6,x5,x4	: out	bit;
	     x3,x2,x1,x0	: out	bit);
    end component;

    component gnd24
	port(x23,x22,x21,x20	: out	bit;
	     x19,x18,x17,x16	: out	bit;
	     x15,x14,x13,x12	: out	bit;
	     x11,x10,x9,x8	: out	bit;
	     x7,x6,x5,x4	: out	bit;
	     x3,x2,x1,x0	: out	bit);
    end component;

    component gnd32
	port(x31,x30,x29,x28	: out	bit;
	     x27,x26,x25,x24	: out	bit;
	     x23,x22,x21,x20	: out	bit;
	     x19,x18,x17,x16	: out	bit;
	     x15,x14,x13,x12	: out	bit;
	     x11,x10,x9,x8	: out	bit;
	     x7,x6,x5,x4	: out	bit;
	     x3,x2,x1,x0	: out	bit);
    end component;

END iopkg;

------

package io_local is
    COMPONENT PAckcell		-- Master Clock Cell.
	PORT (
	    ip	: IN bit;	-- Input pad.
	    ini	: OUT bit;	-- Inverted.
	    iz	: OUT bit;	-- Non-inverted.
	    ic	: OUT bit	-- To "Dedicated clock network".
	);
    END COMPONENT;
    COMPONENT PAincell		-- Master Input Cell.
	PORT (
	    ip	: IN bit;	-- Input pad.
	    ini	: OUT bit;	-- Inverting output of cell.
	    iz	: OUT bit	-- Non-inverting output of cell.
	);
    END COMPONENT;
    COMPONENT PAbicell		-- Master Bi-directional Cell.
	PORT (
	    ie	: IN bit;	-- Output Enable.
	    i1	: IN bit;	-- Inverting input.
	    i2	: IN bit;	-- Non-inverting input.
	    iz	: OUT bit;	-- Path into chip.
	    ip	: inout x01z	-- I/O pad.
	);
    END COMPONENT;
component triout
    port(
	x	: in bit;		-- Logic input to Buffer.
	oe	: in bit;		-- Output Enable input.
	y	: out x01z		-- Output pin.
    );
end component;
component bufoe
    port(
	x	: in bit;		-- Logic input to Buffer.
	oe	: in bit;		-- Output Enable input.
	y	: inout x01z;		-- Output pin.
	yfb	: out bit		-- Output feed back as bit.
    );
end component;
component buf
    port(
	x	: in bit;		-- Input to Buffer.
	y	: out bit		-- Output from Buffer.
    );
end component;
FUNCTION multi_buffer (values : bit_vector) RETURN bit;
end io_local ;
PACKAGE BODY io_local is
  FUNCTION multi_buffer (values : bit_vector) RETURN bit IS
    VARIABLE result : bit := '0';

  BEGIN  --  multi_buffer
    l1 : FOR I IN values'left TO values'right LOOP
    result := result OR values(i);
    END LOOP l1;
    RETURN (result);
  END multi_buffer;
end io_local ;

USE WORK.cypress.ALL;
USE WORK.io_local.ALL;
ENTITY CKPAD IS
    PORT ( 
	p	: IN BIT;
	q	: OUT BIT);
END CKPAD;

ARCHITECTURE archCKPAD OF CKPAD IS
BEGIN
    u1	: PAckcell
	port map (
	    ip	=> P,
	    ini	=> OPEN,
	    iz	=> OPEN,
	    ic	=> Q);
END archCKPAD;

------

USE WORK.cypress.ALL;
USE WORK.io_local.ALL;
ENTITY HDPAD IS
    PORT (
	p	: IN BIT;
	q	: OUT BIT);
END HDPAD;

ARCHITECTURE archHDPAD OF HDPAD IS
BEGIN
    u1	: PAincell
	port map (
	    ip	=> p,
	    ini	=> OPEN,
	    iz	=> q);
END archHDPAD;

------

USE WORK.cypress.ALL;
USE WORK.io_local.ALL;
ENTITY HDIPAD IS
    PORT (
	p	: IN BIT;
	qn	: OUT BIT);
END HDIPAD;

ARCHITECTURE archHDIPAD OF HDIPAD IS
BEGIN
    u1	: PAincell
	port map (
	    ip	=> p,
	    ini	=> qn,
	    iz	=> OPEN);
END archHDIPAD;

------

USE WORK.cypress.ALL;
USE WORK.io_local.ALL;
ENTITY HD2PAD IS
    PORT (
	p0	: IN  BIT;
	p1	: IN  BIT;
	q	: OUT BIT);
END HD2PAD;

ARCHITECTURE archHD2PAD OF HD2PAD IS

	signal o : multi_buffer bit;

BEGIN
    u0	: PAincell port map ( ip => p0, ini => OPEN, iz => o);
    u1	: PAincell port map ( ip => p1, ini => OPEN, iz => o);
    q <= o;

END archHD2PAD;

------

USE WORK.cypress.ALL;
USE WORK.io_local.ALL;
ENTITY HD3PAD IS
    PORT (
	p0	: IN  BIT;
	p1	: IN  BIT;
	p2	: IN  BIT;
	q	: OUT BIT);
END HD3PAD;

ARCHITECTURE archHD3PAD OF HD3PAD IS

	signal o : multi_buffer bit;

BEGIN
    u0	: PAincell port map ( ip => p0, ini => OPEN, iz => o);
    u1	: PAincell port map ( ip => p1, ini => OPEN, iz => o);
    u2	: PAincell port map ( ip => p2, ini => OPEN, iz => o);
    q <= o;

END archHD3PAD;

------

USE WORK.cypress.ALL;
USE WORK.io_local.ALL;
ENTITY HD4PAD IS
    PORT (
	p0	: IN  BIT;
	p1	: IN  BIT;
	p2	: IN  BIT;
	p3	: IN  BIT;
	q	: OUT BIT);
END HD4PAD;

ARCHITECTURE archHD4PAD OF HD4PAD IS

	signal o : multi_buffer bit;

BEGIN
    u0	: PAincell port map ( ip => p0, ini => OPEN, iz => o);
    u1	: PAincell port map ( ip => p1, ini => OPEN, iz => o);
    u2	: PAincell port map ( ip => p2, ini => OPEN, iz => o);
    u3	: PAckcell port map ( ip => p3, ini => OPEN, iz	=> o, ic => OPEN);
    q <= o;

END archHD4PAD;

------

USE WORK.cypress.ALL;
USE WORK.io_local.ALL;
ENTITY INPAD IS
    PORT ( 
	p		: INOUT x01z;
	q		: OUT BIT);
END INPAD;

ARCHITECTURE archINPAD OF INPAD IS

BEGIN
	U0 : PAbicell port map (zero,one,zero,q,p);

END archINPAD;

------

USE WORK.cypress.ALL;
USE WORK.io_local.ALL;
ENTITY OUTPAD IS
    PORT ( 
	a		: IN BIT;
	p		: INOUT x01z);
END OUTPAD;

ARCHITECTURE archOUTPAD OF OUTPAD IS

BEGIN
	U0 : PAbicell port map (one,one,a,OPEN,p);

END archOUTPAD;

------

use work.io_local.all;

entity bufoe2 is
    port(x1, x0, oe	: in	bit;
	 y1, y0		: inout	x01z;
	 yfb1, yfb0	: out	bit);
end bufoe2;

architecture archBUFOE2 of BUFOE2 is
begin

    U1: bufoe port map (x1,oe,y1,yfb1);
    U0: bufoe port map (x0,oe,y0,yfb0);

end archBUFOE2;

------

use work.io_local.all;

entity bufoe3 is
    port(x2,x1,x0,oe	: in	bit;
	 y2,y1,y0	: inout	x01z;
	 yfb2,yfb1,yfb0	: out	bit);
end bufoe3;

architecture archBUFOE3 of BUFOE3 is
begin

    U2: bufoe port map (x2,oe,y2,yfb2);
    U1: bufoe port map (x1,oe,y1,yfb1);
    U0: bufoe port map (x0,oe,y0,yfb0);

end archBUFOE3;

------

use work.io_local.all;
use work.iopkg.all;

entity bufoe4 is
    port(x3,x2,x1,x0,oe		: in	bit;
	 y3,y2,y1,y0		: inout	x01z;
	 yfb3,yfb2,yfb1,yfb0	: out	bit);
end bufoe4;

architecture archBUFOE4 of BUFOE4 is
begin

    U1: bufoe2 port map (x3,x2,oe,y3,y2,yfb3,yfb2);
    U0: bufoe2 port map (x1,x0,oe,y1,y0,yfb1,yfb0);

end archBUFOE4;

------

use work.io_local.all;
use work.iopkg.all;

entity bufoe6 is
    port(x5,x4,x3,x2,x1,x0,oe		: in	bit;
	 y5,y4,y3,y2,y1,y0		: inout	x01z;
	 yfb5,yfb4,yfb3,yfb2,yfb1,yfb0	: out	bit);
end bufoe6;

architecture archBUFOE6 of BUFOE6 is
begin

    U1: bufoe3 port map (x5,x4,x3,oe,y5,y4,y3,yfb5,yfb4,yfb3);
    U0: bufoe3 port map (x2,x1,x0,oe,y2,y1,y0,yfb2,yfb1,yfb0);

end archBUFOE6;

------

use work.io_local.all;
use work.iopkg.all;

entity bufoe8 is
    port(x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y7,y6,y5,y4		: inout	x01z;
	 y3,y2,y1,y0		: inout	x01z;
	 yfb7,yfb6,yfb5,yfb4	: out	bit;
	 yfb3,yfb2,yfb1,yfb0	: out	bit);
end bufoe8;

architecture archBUFOE8 of BUFOE8 is
begin

    U1: bufoe4 port map (x7,x6,x5,x4,oe,y7,y6,y5,y4,yfb7,yfb6,yfb5,yfb4);
    U0: bufoe4 port map (x3,x2,x1,x0,oe,y3,y2,y1,y0,yfb3,yfb2,yfb1,yfb0);

end archBUFOE8;

------

use work.io_local.all;
use work.iopkg.all;

entity bufoe12 is
    port(x11,x10,x9,x8		: in	bit;
	 x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y11,y10,y9,y8		: inout	x01z;
	 y7,y6,y5,y4		: inout	x01z;
	 y3,y2,y1,y0		: inout	x01z;
	 yfb11,yfb10,yfb9,yfb8	: out	bit;
	 yfb7,yfb6,yfb5,yfb4	: out	bit;
	 yfb3,yfb2,yfb1,yfb0	: out	bit);
end bufoe12;

architecture archBUFOE12 of BUFOE12 is
begin

    U2: bufoe4 port map (x11,x10,x9,x8,oe,y11,y10,y9,y8,yfb11,yfb10,yfb9,yfb8);
    U1: bufoe4 port map ( x7, x6,x5,x4,oe, y7, y6,y5,y4, yfb7, yfb6,yfb5,yfb4);
    U0: bufoe4 port map ( x3, x2,x1,x0,oe, y3, y2,y1,y0, yfb3, yfb2,yfb1,yfb0);

end archBUFOE12;

------

use work.io_local.all;
use work.iopkg.all;

entity bufoe16 is
    port(x15,x14,x13,x12	: in	bit;
	 x11,x10,x9,x8		: in	bit;
	 x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y15,y14,y13,y12	: inout	x01z;
	 y11,y10,y9,y8		: inout	x01z;
	 y7,y6,y5,y4		: inout	x01z;
	 y3,y2,y1,y0		: inout	x01z;
	 yfb15,yfb14,yfb13,yfb12: out	bit;
	 yfb11,yfb10,yfb9,yfb8	: out	bit;
	 yfb7,yfb6,yfb5,yfb4	: out	bit;
	 yfb3,yfb2,yfb1,yfb0	: out	bit);
end bufoe16;

architecture archBUFOE16 of BUFOE16 is
begin

    U3: bufoe4 port map (x15,x14,x13,x12,oe,y15,y14,y13,y12,
						yfb15,yfb14,yfb13,yfb12);
    U2: bufoe4 port map (x11,x10,x9,x8,oe,y11,y10,y9,y8,
						yfb11,yfb10,yfb9,yfb8);
    U1: bufoe4 port map ( x7, x6,x5,x4,oe, y7, y6,y5,y4,
   						yfb7,yfb6,yfb5,yfb4);
    U0: bufoe4 port map ( x3, x2,x1,x0,oe, y3, y2,y1,y0,
   						yfb3,yfb2,yfb1,yfb0);

end archBUFOE16;

------

use work.io_local.all;
use work.iopkg.all;

entity bufoe24 is
    port(x23,x22,x21,x20	: in	bit;
	 x19,x18,x17,x16	: in	bit;
	 x15,x14,x13,x12	: in	bit;
	 x11,x10,x9,x8		: in	bit;
	 x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y23,y22,y21,y20	: inout	x01z;
	 y19,y18,y17,y16	: inout	x01z;
	 y15,y14,y13,y12	: inout	x01z;
	 y11,y10,y9,y8		: inout	x01z;
	 y7,y6,y5,y4		: inout	x01z;
	 y3,y2,y1,y0		: inout	x01z;
	 yfb23,yfb22,yfb21,yfb20: out	bit;
	 yfb19,yfb18,yfb17,yfb16: out	bit;
	 yfb15,yfb14,yfb13,yfb12: out	bit;
	 yfb11,yfb10,yfb9,yfb8	: out	bit;
	 yfb7,yfb6,yfb5,yfb4	: out	bit;
	 yfb3,yfb2,yfb1,yfb0	: out	bit);
end bufoe24;

architecture archBUFOE24 of BUFOE24 is
begin

    U5: bufoe4 port map (x23,x22,x21,x20,oe,y23,y22,y21,y20,
						yfb23,yfb22,yfb21,yfb20);
    U4: bufoe4 port map (x19,x18,x17,x16,oe,y19,y18,y17,y16,
						yfb19,yfb18,yfb17,yfb16);
    U3: bufoe4 port map (x15,x14,x13,x12,oe,y15,y14,y13,y12,
						yfb15,yfb14,yfb13,yfb12);
    U2: bufoe4 port map (x11,x10,x9,x8,oe,y11,y10,y9,y8,
						yfb11,yfb10,yfb9,yfb8);
    U1: bufoe4 port map ( x7, x6,x5,x4,oe, y7, y6,y5,y4,
   						yfb7,yfb6,yfb5,yfb4);
    U0: bufoe4 port map ( x3, x2,x1,x0,oe, y3, y2,y1,y0,
   						yfb3,yfb2,yfb1,yfb0);

end archBUFOE24;

------

use work.io_local.all;
use work.iopkg.all;

entity bufoe32 is
    port(x31,x30,x29,x28	: in	bit;
	 x27,x26,x25,x24	: in	bit;
	 x23,x22,x21,x20	: in	bit;
	 x19,x18,x17,x16	: in	bit;
	 x15,x14,x13,x12	: in	bit;
	 x11,x10,x9,x8		: in	bit;
	 x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y31,y30,y29,y28	: inout	x01z;
	 y27,y26,y25,y24	: inout	x01z;
	 y23,y22,y21,y20	: inout	x01z;
	 y19,y18,y17,y16	: inout	x01z;
	 y15,y14,y13,y12	: inout	x01z;
	 y11,y10,y9,y8		: inout	x01z;
	 y7,y6,y5,y4		: inout	x01z;
	 y3,y2,y1,y0		: inout	x01z;
	 yfb31,yfb30,yfb29,yfb28: out	bit;
	 yfb27,yfb26,yfb25,yfb24: out	bit;
	 yfb23,yfb22,yfb21,yfb20: out	bit;
	 yfb19,yfb18,yfb17,yfb16: out	bit;
	 yfb15,yfb14,yfb13,yfb12: out	bit;
	 yfb11,yfb10,yfb9,yfb8	: out	bit;
	 yfb7,yfb6,yfb5,yfb4	: out	bit;
	 yfb3,yfb2,yfb1,yfb0	: out	bit);
end bufoe32;

architecture archBUFOE32 of BUFOE32 is
begin

    U7: bufoe4 port map (x31,x30,x29,x28,oe,y31,y30,y29,y28,
						yfb31,yfb30,yfb29,yfb28);
    U6: bufoe4 port map (x27,x26,x25,x24,oe,y27,y26,y25,y24,
						yfb27,yfb26,yfb25,yfb24);
    U5: bufoe4 port map (x23,x22,x21,x20,oe,y23,y22,y21,y20,
						yfb23,yfb22,yfb21,yfb20);
    U4: bufoe4 port map (x19,x18,x17,x16,oe,y19,y18,y17,y16,
						yfb19,yfb18,yfb17,yfb16);
    U3: bufoe4 port map (x15,x14,x13,x12,oe,y15,y14,y13,y12,
						yfb15,yfb14,yfb13,yfb12);
    U2: bufoe4 port map (x11,x10,x9,x8,oe,y11,y10,y9,y8,
						yfb11,yfb10,yfb9,yfb8);
    U1: bufoe4 port map ( x7, x6,x5,x4,oe, y7, y6,y5,y4,
   						yfb7,yfb6,yfb5,yfb4);
    U0: bufoe4 port map ( x3, x2,x1,x0,oe, y3, y2,y1,y0,
   						yfb3,yfb2,yfb1,yfb0);

end archBUFOE32;

------

use work.io_local.all;

entity triout2 is
    port(x1, x0, oe	: in	bit;
	 y1, y0		: out	x01z);
end triout2;

architecture archtriout2 of triout2 is
begin

    U1: triout port map (x1,oe,y1);
    U0: triout port map (x0,oe,y0);

end archtriout2;

------

use work.io_local.all;

entity triout3 is
    port(x2,x1,x0,oe	: in	bit;
	 y2,y1,y0	: out	x01z);
end triout3;

architecture archtriout3 of triout3 is
begin

    U2: triout port map (x2,oe,y2);
    U1: triout port map (x1,oe,y1);
    U0: triout port map (x0,oe,y0);

end archtriout3;

------

use work.io_local.all;
use work.iopkg.all;

entity triout4 is
    port(x3,x2,x1,x0,oe		: in	bit;
	 y3,y2,y1,y0		: out	x01z);
end triout4;

architecture archtriout4 of triout4 is
begin

    U1: triout2 port map (x3,x2,oe,y3,y2);
    U0: triout2 port map (x1,x0,oe,y1,y0);

end archtriout4;

------

use work.io_local.all;
use work.iopkg.all;

entity triout6 is
    port(x5,x4,x3,x2,x1,x0,oe		: in	bit;
	 y5,y4,y3,y2,y1,y0		: out	x01z);
end triout6;

architecture archtriout6 of triout6 is
begin

    U1: triout3 port map (x5,x4,x3,oe,y5,y4,y3);
    U0: triout3 port map (x2,x1,x0,oe,y2,y1,y0);

end archtriout6;

------

use work.io_local.all;
use work.iopkg.all;

entity triout8 is
    port(x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y7,y6,y5,y4		: out	x01z;
	 y3,y2,y1,y0		: out	x01z);
end triout8;

architecture archtriout8 of triout8 is
begin

    U1: triout4 port map (x7,x6,x5,x4,oe,y7,y6,y5,y4);
    U0: triout4 port map (x3,x2,x1,x0,oe,y3,y2,y1,y0);

end archtriout8;

------

use work.io_local.all;
use work.iopkg.all;

entity triout12 is
    port(x11,x10,x9,x8		: in	bit;
	 x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y11,y10,y9,y8		: out	x01z;
	 y7,y6,y5,y4		: out	x01z;
	 y3,y2,y1,y0		: out	x01z);
end triout12;

architecture archtriout12 of triout12 is
begin

    U2: triout4 port map (x11,x10,x9,x8,oe,y11,y10,y9,y8);
    U1: triout4 port map ( x7, x6,x5,x4,oe, y7, y6,y5,y4);
    U0: triout4 port map ( x3, x2,x1,x0,oe, y3, y2,y1,y0);

end archtriout12;

------

use work.io_local.all;
use work.iopkg.all;

entity triout16 is
    port(x15,x14,x13,x12	: in	bit;
	 x11,x10,x9,x8		: in	bit;
	 x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y15,y14,y13,y12	: out	x01z;
	 y11,y10,y9,y8		: out	x01z;
	 y7,y6,y5,y4		: out	x01z;
	 y3,y2,y1,y0		: out	x01z);
end triout16;

architecture archtriout16 of triout16 is
begin

    U3: triout4 port map (x15,x14,x13,x12,oe,y15,y14,y13,y12);
    U2: triout4 port map (x11,x10, x9, x8,oe,y11,y10, y9, y8);
    U1: triout4 port map ( x7, x6, x5, x4,oe, y7, y6, y5, y4);
    U0: triout4 port map ( x3, x2, x1, x0,oe, y3, y2, y1, y0);

end archtriout16;

------

use work.io_local.all;
use work.iopkg.all;

entity triout24 is
    port(x23,x22,x21,x20	: in	bit;
	 x19,x18,x17,x16	: in	bit;
	 x15,x14,x13,x12	: in	bit;
	 x11,x10,x9,x8		: in	bit;
	 x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y23,y22,y21,y20	: out	x01z;
	 y19,y18,y17,y16	: out	x01z;
	 y15,y14,y13,y12	: out	x01z;
	 y11,y10,y9,y8		: out	x01z;
	 y7,y6,y5,y4		: out	x01z;
	 y3,y2,y1,y0		: out	x01z);
end triout24;

architecture archtriout24 of triout24 is
begin

    U5: triout4 port map (x23,x22,x21,x20,oe,y23,y22,y21,y20);
    U4: triout4 port map (x19,x18,x17,x16,oe,y19,y18,y17,y16);
    U3: triout4 port map (x15,x14,x13,x12,oe,y15,y14,y13,y12);
    U2: triout4 port map (x11,x10, x9, x8,oe,y11,y10, y9, y8);
    U1: triout4 port map ( x7, x6, x5, x4,oe, y7, y6, y5, y4);
    U0: triout4 port map ( x3, x2, x1, x0,oe, y3, y2, y1, y0);

end archtriout24;

------

use work.io_local.all;
use work.iopkg.all;

entity triout32 is
    port(x31,x30,x29,x28	: in	bit;
	 x27,x26,x25,x24	: in	bit;
	 x23,x22,x21,x20	: in	bit;
	 x19,x18,x17,x16	: in	bit;
	 x15,x14,x13,x12	: in	bit;
	 x11,x10,x9,x8		: in	bit;
	 x7,x6,x5,x4		: in	bit;
	 x3,x2,x1,x0,oe		: in	bit;
	 y31,y30,y29,y28	: out	x01z;
	 y27,y26,y25,y24	: out	x01z;
	 y23,y22,y21,y20	: out	x01z;
	 y19,y18,y17,y16	: out	x01z;
	 y15,y14,y13,y12	: out	x01z;
	 y11,y10,y9,y8		: out	x01z;
	 y7,y6,y5,y4		: out	x01z;
	 y3,y2,y1,y0		: out	x01z);
end triout32;

architecture archtriout32 of triout32 is
begin

    U7: triout4 port map (x31,x30,x29,x28,oe,y31,y30,y29,y28);
    U6: triout4 port map (x27,x26,x25,x24,oe,y27,y26,y25,y24);
    U5: triout4 port map (x23,x22,x21,x20,oe,y23,y22,y21,y20);
    U4: triout4 port map (x19,x18,x17,x16,oe,y19,y18,y17,y16);
    U3: triout4 port map (x15,x14,x13,x12,oe,y15,y14,y13,y12);
    U2: triout4 port map (x11,x10, x9, x8,oe,y11,y10, y9, y8);
    U1: triout4 port map ( x7, x6, x5, x4,oe, y7, y6, y5, y4);
    U0: triout4 port map ( x3, x2, x1, x0,oe, y3, y2, y1, y0);

end archtriout32;

------

use work.io_local.all;

entity gnd2 is
    port(x1, x0	: out	bit);
end gnd2;

architecture archgnd2 of gnd2 is
begin

    U1: buf port map (zero,x1);
    U0: buf port map (zero,x0);

end archgnd2;

------

use work.io_local.all;

entity gnd3 is
    port(x2,x1,x0	: out	bit);
end gnd3;

architecture archgnd3 of gnd3 is
begin

    U2: buf port map (zero,x2);
    U1: buf port map (zero,x1);
    U0: buf port map (zero,x0);

end archgnd3;

------

use work.io_local.all;
use work.iopkg.all;

entity gnd4 is
    port(x3,x2,x1,x0		: out	bit);
end gnd4;

architecture archgnd4 of gnd4 is
begin

    U1: gnd2 port map (x3,x2);
    U0: gnd2 port map (x1,x0);

end archgnd4;

------

use work.io_local.all;
use work.iopkg.all;

entity gnd6 is
    port(x5,x4,x3,x2,x1,x0		: out	bit);
end gnd6;

architecture archgnd6 of gnd6 is
begin

    U1: gnd3 port map (x5,x4,x3);
    U0: gnd3 port map (x2,x1,x0);

end archgnd6;

------

use work.io_local.all;
use work.iopkg.all;

entity gnd8 is
    port(x7,x6,x5,x4		: out	bit;
	 x3,x2,x1,x0		: out	bit);
end gnd8;

architecture archgnd8 of gnd8 is
begin

    U1: gnd4 port map (x7,x6,x5,x4);
    U0: gnd4 port map (x3,x2,x1,x0);

end archgnd8;

------

use work.io_local.all;
use work.iopkg.all;

entity gnd12 is
    port(x11,x10,x9,x8		: out	bit;
	 x7,x6,x5,x4		: out	bit;
	 x3,x2,x1,x0		: out	bit);
end gnd12;

architecture archgnd12 of gnd12 is
begin

    U2: gnd4 port map (x11,x10,x9,x8);
    U1: gnd4 port map ( x7, x6,x5,x4);
    U0: gnd4 port map ( x3, x2,x1,x0);

end archgnd12;

------

use work.io_local.all;
use work.iopkg.all;

entity gnd16 is
    port(x15,x14,x13,x12	: out	bit;
	 x11,x10,x9,x8		: out	bit;
	 x7,x6,x5,x4		: out	bit;
	 x3,x2,x1,x0		: out	bit);
end gnd16;

architecture archgnd16 of gnd16 is
begin

    U3: gnd4 port map (x15,x14,x13,x12);
    U2: gnd4 port map (x11,x10,x9,x8);
    U1: gnd4 port map ( x7, x6,x5,x4);
    U0: gnd4 port map ( x3, x2,x1,x0);

end archgnd16;

------

use work.io_local.all;
use work.iopkg.all;

entity gnd24 is
    port(x23,x22,x21,x20	: out	bit;
	 x19,x18,x17,x16	: out	bit;
	 x15,x14,x13,x12	: out	bit;
	 x11,x10,x9,x8		: out	bit;
	 x7,x6,x5,x4		: out	bit;
	 x3,x2,x1,x0		: out	bit);
end gnd24;

architecture archgnd24 of gnd24 is
begin

    U5: gnd4 port map (x23,x22,x21,x20);
    U4: gnd4 port map (x19,x18,x17,x16);
    U3: gnd4 port map (x15,x14,x13,x12);
    U2: gnd4 port map (x11,x10,x9,x8);
    U1: gnd4 port map ( x7, x6,x5,x4);
    U0: gnd4 port map ( x3, x2,x1,x0);

end archgnd24;

------

use work.io_local.all;
use work.iopkg.all;

entity gnd32 is
    port(x31,x30,x29,x28	: out	bit;
	 x27,x26,x25,x24	: out	bit;
	 x23,x22,x21,x20	: out	bit;
	 x19,x18,x17,x16	: out	bit;
	 x15,x14,x13,x12	: out	bit;
	 x11,x10,x9,x8		: out	bit;
	 x7,x6,x5,x4		: out	bit;
	 x3,x2,x1,x0		: out	bit);
end gnd32;

architecture archgnd32 of gnd32 is
begin

    U7: gnd4 port map (x31,x30,x29,x28);
    U6: gnd4 port map (x27,x26,x25,x24);
    U5: gnd4 port map (x23,x22,x21,x20);
    U4: gnd4 port map (x19,x18,x17,x16);
    U3: gnd4 port map (x15,x14,x13,x12);
    U2: gnd4 port map (x11,x10,x9,x8);
    U1: gnd4 port map ( x7, x6,x5,x4);
    U0: gnd4 port map ( x3, x2,x1,x0);

end archgnd32;

