--
--      Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--        as an unpublished work.
--

PACKAGE mathpkg IS 

    COMPONENT ADD
	PORT(CI  : IN bit;
	     A   : IN bit;
	     B   : IN bit;
	     SUM : INOUT bit;
	     CO  : INOUT bit);
    END COMPONENT;

    COMPONENT SUB
	PORT(CI  : IN bit;
	     A   : IN bit;
	     B   : IN bit;
	     DIF : INOUT bit;
	     CO  : INOUT bit);
    END COMPONENT;

    COMPONENT ADD4
	PORT(CI,A3,A2,A1,A0,B3,B2,B1,B0 : IN bit;
	     SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT FCADD4
	PORT(CI,A3,A2,A1,A0,B3,B2,B1,B0 : IN bit;
	     SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT FBSUB4
	PORT(CI,A3,A2,A1,A0,B3,B2,B1,B0 : IN bit;
	     DIF3,DIF2,DIF1,DIF0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT ADD8
	PORT(CI,A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	     SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT FCADD8
	PORT(CI,A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	     SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT NCIADD8
	PORT(A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	     SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT FBSUB8
	PORT(CI,A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	     DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT ADD16
	PORT(CI,A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
		B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
		SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8,
		SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT FCADD16
	PORT(CI,A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
		B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
		SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8,
		SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT NCIADD16
	PORT(   A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
		B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
		SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8,
		SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT FBSUB16
	PORT(CI,A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
		B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
		DIF15,DIF14,DIF13,DIF12,DIF11,DIF10,DIF9,DIF8,
		DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0,CO : INOUT bit);
    END COMPONENT;

    COMPONENT mult4x4
	port(B3,B2,B1,B0,M3,M2,M1,M0: IN bit;
	     Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0: INOUT bit);
    END COMPONENT;

    COMPONENT COMPBIT2
	PORT (
	    A0,B0,A1,B1			: IN	BIT;
	    EQ0,EQ1			: INOUT	BIT
	);
    END COMPONENT;

    COMPONENT EQCOMP4
	PORT (A3,A2,A1,A0,B3,B2,B1,B0 : IN BIT;
	    EQ	: INOUT	BIT);
    END COMPONENT;

    COMPONENT EQCOMP8
	PORT (A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: INOUT	BIT);
    END COMPONENT;

    COMPONENT EQCOMP16
	PORT (A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0 : IN BIT;
	      B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: INOUT	BIT);
    END COMPONENT;

END mathpkg;

package mathpkg_local is
component buf
    port(
	x	: in bit;		-- Input to Buffer.
	y	: out bit		-- Output from Buffer.
    );
end component;
COMPONENT PAlcell
	PORT (
	    qs	: IN bit;	-- Async Set on FF(Q).

	    a1	: IN bit;	-- Non-invert to AND A.
	    a2	: IN bit;	-- Invert to AND A.
	    a3	: IN bit;	-- Non-invert to AND A.
	    a4	: IN bit;	-- Invert to AND A.
	    a5	: IN bit;	-- Non-invert to AND A.
	    a6	: IN bit;	-- Invert to AND A.

	    b1	: IN bit;	-- Non-invert to AND B.
	    b2	: IN bit;	-- Invert to AND B.

	    c1	: IN bit;	-- Non-invert to AND C.
	    c2	: IN bit;	-- Invert to AND C.

	    d1	: IN bit;	-- Non-invert to AND D.
	    d2	: IN bit;	-- Invert to AND D.

	    e1	: IN bit;	-- Non-invert to AND E.
	    e2	: IN bit;	-- Invert to AND E.

	    f1	: IN bit;	-- Non-invert to AND F.
	    f2	: IN bit;	-- Invert to AND F.
	    f3	: IN bit;	-- Non-invert to AND F.
	    f4	: IN bit;	-- Invert to AND F.
	    f5	: IN bit;	-- Non-invert to AND F.
	    f6	: IN bit;	-- Invert to AND F.

	    qc	: IN bit;	-- Clock to FF(Q).
	    qr	: IN bit;	-- Async Reset on FF(Q).

	    az	: OUT bit;	-- Output of AND A.
	    oz	: OUT bit;	-- Output of MUX O.
	    qz	: OUT bit;	-- Output of FF  Q.
	    nz	: OUT bit;	-- Output of MUX N.
	    fz	: OUT bit	-- Output of AND F.
	);
    END COMPONENT;
    COMPONENT logico		-- Master Logic Cell.
	PORT (
	    a1	: IN bit;	-- Non-invert to AND A.
	    a2	: IN bit;	-- Invert to AND A.
	    a3	: IN bit;	-- Non-invert to AND A.
	    a4	: IN bit;	-- Invert to AND A.
	    a5	: IN bit;	-- Non-invert to AND A.
	    a6	: IN bit;	-- Invert to AND A.

	    b1	: IN bit;	-- Non-invert to AND B.
	    b2	: IN bit;	-- Invert to AND B.

	    c1	: IN bit;	-- Non-invert to AND C.
	    c2	: IN bit;	-- Invert to AND C.

	    d1	: IN bit;	-- Non-invert to AND D.
	    d2	: IN bit;	-- Invert to AND D.

	    e1	: IN bit;	-- Non-invert to AND E.
	    e2	: IN bit;	-- Invert to AND E.

	    f1	: IN bit;	-- Non-invert to AND F.
	    f2	: IN bit;	-- Invert to AND F.
	    f3	: IN bit;	-- Non-invert to AND F.
	    f4	: IN bit;	-- Invert to AND F.
	    f5	: IN bit;	-- Non-invert to AND F.
	    f6	: IN bit;	-- Invert to AND F.

	    oz	: OUT bit	-- Output of MUX O.
	);
    END COMPONENT;
    COMPONENT PAfrag_a
	PORT (
	    a1	: IN bit;	-- Non-invert to AND A.
	    a2	: IN bit;	-- Invert to AND A.
	    a3	: IN bit;	-- Non-invert to AND A.
	    a4	: IN bit;	-- Invert to AND A.
	    a5	: IN bit;	-- Non-invert to AND A.
	    a6	: IN bit;	-- Invert to AND A.

	    az	: OUT bit	-- Output of AND A.
	);
    END COMPONENT;
end mathpkg_local ;
------------

--
--	ADD
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity ADD is
   port(CI  : IN bit;
         A  : IN bit;
         B  : IN bit;
	 SUM: INOUT bit;
	 CO : INOUT bit);
end ADD;

architecture archADD of ADD is

begin

    XS: logico port map(one,B,one,zero,one,zero,
			CI,zero,one,CI,one,CI,CI,zero,
			one,A,one,zero,one,zero,SUM);
    XC: logico port map(one,B,one,zero,one,zero,
			one,zero,CI,zero,CI,zero,zero,one,
			one,A,one,zero,one,zero,CO);

end archADD;

--
--	SUB
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity SUB is
   port(CI  : IN bit;
         A  : IN bit;
         B  : IN bit;
	 DIF: INOUT bit;
	 CO : INOUT bit);
end SUB;

architecture archSUB of SUB is

begin

    XS: logico port map(one,B,one,zero,one,zero,
			CI,zero,one,CI,one,CI,CI,zero,
			one,A,one,zero,one,zero,DIF);
    XC: logico port map(one,B,one,zero,one,zero,
			CI,zero,one,zero,zero,one,CI,zero,
			one,A,one,zero,one,zero,CO);

end archSUB;

--
--	ADD4
--

use work.mathpkg.all;
ENTITY ADD4 IS
    PORT(CI, A3, A2, A1, A0, B3, B2, B1, B0  : IN bit;
	 SUM3, SUM2, SUM1, SUM0, CO  : INOUT bit);
END ADD4;

ARCHITECTURE archADD4 OF ADD4 IS
BEGIN

	U0:fcadd4 port map (ci,a3,a2,a1,a0,b3,b2,b1,b0,sum3,sum2,sum1,sum0,co);

END archADD4;

--
--	FCADD4
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity FCADD4 is
    PORT(CI, A3, A2, A1, A0, B3, B2, B1, B0  : IN bit;
	 SUM3, SUM2, SUM1, SUM0, CO  : INOUT bit);
end FCADD4;

ARCHITECTURE archFCADD4 OF FCADD4 IS

    signal lo,hi,c1x,a1t			: bit;
    signal c0,c1,s2,c02,c12,s3,c3,c03,c13	: bit;

begin
    lo <= '0';
    hi <= '1';

    S1: logico port map(b1,lo,hi,lo,hi,lo,
			c0,lo,hi,C0,hi,C0,C0,lo,
			a1t,lo,hi,lo,hi,lo,sum1);
    S2: logico port map(c1x,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			S2,lo,hi,lo,hi,lo,sum2);
    S3: logico port map(c1x,lo,hi,lo,hi,lo,
			c02,lo,hi,C02,hi,C12,c12,lo,
			S3,lo,hi,lo,hi,lo,sum3);

    B1: buf port map (c1,c1x);

    X0S: logico port map(hi,A0,hi,lo,hi,lo,
			CI,lo,hi,CI,hi,CI,CI,lo,
			hi,B0,hi,lo,hi,lo,sum0);
    X0C: logico port map(hi,A0,hi,lo,hi,lo,
			hi,lo,CI,lo,CI,lo,lo,hi,
			hi,B0,hi,lo,hi,lo,C0);
    X1: palcell port map(lo, 
			C0,lo,hi,lo,hi,lo,
			lo,hi,B1,lo,B1,lo,hi,lo,
			A1,lo,hi,lo,hi,lo,
			lo,lo,open,C1,open,open,A1T);
    X2: palcell port map(lo,
			A2,lo,B2,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A2,hi,B2,hi,lo,
			lo,lo,C02,S2,open,open,C12);
    X3: palcell port map(lo,
			A3,lo,B3,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A3,hi,B3,hi,lo,
			lo,lo,C03,S3,open,open,C13);
    CO: logico port map(a3,lo,hi,lo,hi,lo,
			lo,hi,b3,lo,b3,lo,hi,lo,
			hi,sum3,hi,lo,hi,lo,co);

END archFCADD4;

--
--	FBSUB4
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity FBSUB4 is
    PORT(CI, A3, A2, A1, A0, B3, B2, B1, B0  : IN bit;
	 DIF3, DIF2, DIF1, DIF0, CO  : INOUT bit);
end FBSUB4;

ARCHITECTURE archFBSUB4 OF FBSUB4 IS

    signal lo,hi,c1x,a1t			: bit;
    signal c0,c1,s2,c02,c12,s3,c3,c03,c13	: bit;

begin
    lo <= '0';
    hi <= '1';

    S1: logico port map(b1,lo,hi,lo,hi,lo,
			c0,lo,hi,C0,hi,C0,C0,lo,
			a1t,lo,hi,lo,hi,lo,dif1);
    S2: logico port map(c1x,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			S2,lo,hi,lo,hi,lo,dif2);
    S3: logico port map(c1x,lo,hi,lo,hi,lo,
			c02,lo,hi,C02,hi,C12,c12,lo,
			S3,lo,hi,lo,hi,lo,dif3);

    B1: buf port map (c1,c1x);

    X0S: logico port map(hi,B0,hi,lo,hi,lo,
			CI,lo,hi,CI,hi,CI,CI,lo,
			hi,A0,hi,lo,hi,lo,dif0);
    X0C: logico port map(hi,B0,hi,lo,hi,lo,
			CI,lo,hi,lo,lo,hi,CI,lo,
			hi,A0,hi,lo,hi,lo,C0);
    X1: palcell port map(lo,
			C0,lo,hi,lo,hi,lo,
			hi,B1,hi,lo,lo,hi,hi,B1,
			A1,lo,hi,lo,hi,lo,
			lo,lo,open,C1,open,open,A1T);
    X2: palcell port map(lo,
			A2,B2,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B2,A2,hi,lo,hi,lo,
			lo,lo,C02,S2,open,open,C12);
    X3: palcell port map(lo,
			A3,B3,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B3,A3,hi,lo,hi,lo,
			lo,lo,C03,S3,open,open,C13);
    CO: logico port map(dif3,lo,hi,lo,hi,lo,
			lo,hi,b3,lo,b3,lo,hi,lo,
			hi,a3,hi,lo,hi,lo,co);

END archFBSUB4;

--
--	ADD8
--

use work.mathpkg.all;
ENTITY ADD8 IS
    PORT(CI,A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	 SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
END ADD8;

ARCHITECTURE archADD8 OF ADD8 IS
BEGIN

	U0:fcadd8 port map (ci, a7,a6,a5,a4,a3,a2,a1,a0,
				b7,b6,b5,b4,b3,b2,b1,b0,
	    sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,co);

END archADD8;

--
--	FCADD8
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity fcadd8 is
    PORT(CI,A7,A6,A5,A4,A3,A2,A1,A0,
	    B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	    sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,CO : INOUT bit);
end fcadd8;

architecture archFCADD8 of FCADD8 is

    signal lo,hi,c1x,c3x,c7x,a1t			: bit;
    signal c0,c1,s2,c02,c12,s3,c3,c03,c13		: bit;
    signal c04,c14,s5,c05,c15,c06,c16,s7,c7,c07,c17	: bit;
    signal ya,yb,yc,yd,ye,yf,yg,yh,yi,yj,yk,yl,ym,yn,yo	: bit;
    signal za,zb,zc,zd,ze,zf,zg,zh,zi,zj,zk,zl,zm,zn,zo	: bit;
    signal zex,zfx					: bit;
    signal uv,uw,ub					: bit;

begin
    lo <= '0';
    hi <= '1';

    MA: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			c05,lo,hi,c15,c05,lo,hi,c15,
			a4,lo,b4,lo,hi,lo,
			zero,zero,open,ya,open,za,c04);
    MB: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,c15,c05,lo,hi,c15,c05,lo,
			hi,lo,hi,a4,hi,b4,
			zero,zero,open,yb,open,zb,c14);
    MC: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s7,lo,hi,s7,c07,lo,hi,c17,
			a6,lo,b6,lo,hi,lo,
			zero,zero,open,yc,open,zc,c06);
    MD: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s7,s7,lo,hi,c17,c07,lo,
			hi,lo,hi,a6,hi,b6,
			zero,zero,open,yd,open,zd,c16);

    C3: palcell port map(lo,
			c02,lo,hi,lo,hi,lo,
			c03,lo,hi,c13,hi,c13,hi,c13,
			c1,c12,hi,lo,hi,lo,
			lo,lo,open,c3,open,open,open);

    S1: logico port map(b1,lo,hi,lo,hi,lo,
			c0,lo,hi,C0,hi,C0,C0,lo,
			a1t,lo,hi,lo,hi,lo,sum1);
    S2: logico port map(c1x,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			S2,lo,hi,lo,hi,lo,sum2);
    S3: logico port map(c1x,lo,hi,lo,hi,lo,
			c02,lo,hi,C02,hi,C12,c12,lo,
			S3,lo,hi,lo,hi,lo,sum3);
    S4: logico port map(hi,lo,hi,C04,hi,C14,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c3,lo,hi,lo,hi,lo,sum4);
    S5: logico port map(c3,lo,hi,lo,hi,lo,
			c04,lo,hi,C04,hi,C14,c14,lo,
			S5,lo,hi,lo,hi,lo,sum5);
    S6: logico port map(c3,lo,hi,lo,hi,lo,
			ya,lo,hi,ya,yb,lo,hi,yb,
			hi,C06,hi,C16,hi,lo,sum6);
    S7: logico port map(ya,lo,hi,lo,hi,lo,
			yc,lo,yd,lo,yd,lo,yd,lo,
			c3,lo,yb,lo,hi,lo,sum7);

    B1: buf port map (c1,c1x);

    X0S: logico port map(hi,A0,hi,lo,hi,lo,
			CI,lo,hi,CI,hi,CI,CI,lo,
			hi,B0,hi,lo,hi,lo,sum0);
    X0C: logico port map(hi,A0,hi,lo,hi,lo,
			hi,lo,CI,lo,CI,lo,lo,hi,
			hi,B0,hi,lo,hi,lo,C0);
    X1: palcell port map(lo, 
			C0,lo,hi,lo,hi,lo,
			lo,hi,B1,lo,B1,lo,hi,lo,
			A1,lo,hi,lo,hi,lo,
			lo,lo,open,C1,open,open,A1T);
    X2: palcell port map(lo,
			A2,lo,B2,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A2,hi,B2,hi,lo,
			lo,lo,C02,S2,open,open,C12);
    X3: palcell port map(lo,
			A3,lo,B3,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A3,hi,B3,hi,lo,
			lo,lo,C03,S3,open,open,C13);
    X5: palcell port map(lo,
			A5,lo,B5,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A5,hi,B5,hi,lo,
			lo,lo,C05,S5,open,open,C15);
    X7: palcell port map(lo,
			A7,lo,B7,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A7,hi,B7,hi,lo,
			lo,lo,C07,S7,open,open,C17);
    CO: logico port map(a7,lo,hi,lo,hi,lo,
			lo,hi,b7,lo,b7,lo,hi,lo,
			hi,sum7,hi,lo,hi,lo,co);

end archFCADD8;

--
--	NCIADD8
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity NCIADD8 is
    PORT(   A7,A6,A5,A4,A3,A2,A1,A0,
	    B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	    sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,CO : INOUT bit);
end NCIADD8;

architecture archNCIADD8 of NCIADD8 is

    signal lo,hi,c1x,c3x,c7x,a1t			: bit;
    signal c0,c1,s2,c02,c12,s3,c3,c03,c13		: bit;
    signal c04,c14,s5,c05,c15,c06,c16,s7,c7,c07,c17	: bit;
    signal ya,yb,yc,yd,ye,yf,yg,yh,yi,yj,yk,yl,ym,yn,yo	: bit;
    signal za,zb,zc,zd,ze,zf,zg,zh,zi,zj,zk,zl,zm,zn,zo	: bit;
    signal zex,zfx					: bit;
    signal uv,uw,ub					: bit;

begin
    lo <= '0';
    hi <= '1';

    MA: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			c05,lo,hi,c15,c05,lo,hi,c15,
			a4,lo,b4,lo,hi,lo,
			zero,zero,open,ya,open,za,c04);
    MB: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,c15,c05,lo,hi,c15,c05,lo,
			hi,lo,hi,a4,hi,b4,
			zero,zero,open,yb,open,zb,c14);
    MC: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s7,lo,hi,s7,c07,lo,hi,c17,
			a6,lo,b6,lo,hi,lo,
			zero,zero,open,yc,open,zc,c06);
    MD: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s7,s7,lo,hi,c17,c07,lo,
			hi,lo,hi,a6,hi,b6,
			zero,zero,open,yd,open,zd,c16);

    C3: palcell port map(lo,
			c02,lo,hi,lo,hi,lo,
			c03,lo,hi,c13,hi,c13,hi,c13,
			c1,c12,hi,lo,hi,lo,
			lo,lo,open,c3,open,open,open);

    S1: logico port map(b1,lo,hi,lo,hi,lo,
			c0,lo,hi,C0,hi,C0,C0,lo,
			a1t,lo,hi,lo,hi,lo,sum1);
    S2: logico port map(c1x,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			S2,lo,hi,lo,hi,lo,sum2);
    S3: logico port map(c1x,lo,hi,lo,hi,lo,
			c02,lo,hi,C02,hi,C12,c12,lo,
			S3,lo,hi,lo,hi,lo,sum3);
    S4: logico port map(hi,lo,hi,C04,hi,C14,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c3,lo,hi,lo,hi,lo,sum4);
    S5: logico port map(c3,lo,hi,lo,hi,lo,
			c04,lo,hi,C04,hi,C14,c14,lo,
			S5,lo,hi,lo,hi,lo,sum5);
    S6: logico port map(c3,lo,hi,lo,hi,lo,
			ya,lo,hi,ya,yb,lo,hi,yb,
			hi,C06,hi,C16,hi,lo,sum6);
    S7: logico port map(ya,lo,hi,lo,hi,lo,
			yc,lo,yd,lo,yd,lo,yd,lo,
			c3,lo,yb,lo,hi,lo,sum7);

    B1: buf port map (c1,c1x);

    X0: logico port map(hi,A0,hi,B0,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			C0,lo,hi,lo,hi,lo,sum0);
    X1: palcell port map(lo, 
			A0,lo,B0,lo,hi,lo,
			lo,hi,B1,lo,B1,lo,hi,lo,
			A1,lo,hi,lo,hi,lo,
			lo,lo,C0,C1,open,open,A1T);
    X2: palcell port map(lo,
			A2,lo,B2,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A2,hi,B2,hi,lo,
			lo,lo,C02,S2,open,open,C12);
    X3: palcell port map(lo,
			A3,lo,B3,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A3,hi,B3,hi,lo,
			lo,lo,C03,S3,open,open,C13);
    X5: palcell port map(lo,
			A5,lo,B5,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A5,hi,B5,hi,lo,
			lo,lo,C05,S5,open,open,C15);
    X7: palcell port map(lo,
			A7,lo,B7,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A7,hi,B7,hi,lo,
			lo,lo,C07,S7,open,open,C17);
    CO: logico port map(a7,lo,hi,lo,hi,lo,
			lo,hi,b7,lo,b7,lo,hi,lo,
			hi,sum7,hi,lo,hi,lo,co);

end archNCIADD8;

--
--	FBSUB8
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity FBSUB8 is
    PORT(CI,A7,A6,A5,A4,A3,A2,A1,A0,
	    B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	    dif7,dif6,dif5,dif4,dif3,dif2,dif1,dif0,CO : INOUT bit);
end FBSUB8;

architecture archFBSUB8 of FBSUB8 is

    signal lo,hi,c1x,c3x,c7x,a1t			: bit;
    signal c0,c1,s2,c02,c12,s3,c3,c03,c13		: bit;
    signal c04,c14,s5,c05,c15,c06,c16,s7,c7,c07,c17	: bit;
    signal ya,yb,yc,yd,ye,yf,yg,yh,yi,yj,yk,yl,ym,yn,yo	: bit;
    signal za,zb,zc,zd,ze,zf,zg,zh,zi,zj,zk,zl,zm,zn,zo	: bit;
    signal zex,zfx					: bit;
    signal uv,uw,ub					: bit;

begin
    lo <= '0';
    hi <= '1';

    MA: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			c05,lo,hi,c15,c05,lo,hi,c15,
			a4,b4,hi,lo,hi,lo,
			zero,zero,open,ya,open,za,c04);
    MB: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,c15,c05,lo,hi,c15,c05,lo,
			hi,lo,hi,a4,b4,lo,
			zero,zero,open,yb,open,zb,c14);
    MC: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s7,lo,hi,s7,c07,lo,hi,c17,
			a6,b6,hi,lo,hi,lo,
			zero,zero,open,yc,open,zc,c06);
    MD: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s7,s7,lo,hi,c17,c07,lo,
			hi,lo,hi,a6,b6,lo,
			zero,zero,open,yd,open,zd,c16);

    C3: palcell port map(lo,
			c02,lo,hi,lo,hi,lo,
			c03,lo,hi,c13,hi,c13,hi,c13,
			c1,c12,hi,lo,hi,lo,
			lo,lo,open,c3,open,open,open);

    S1: logico port map(b1,lo,hi,lo,hi,lo,
			c0,lo,hi,C0,hi,C0,C0,lo,
			a1t,lo,hi,lo,hi,lo,dif1);
    S2: logico port map(c1x,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			S2,lo,hi,lo,hi,lo,dif2);
    S3: logico port map(c1x,lo,hi,lo,hi,lo,
			c02,lo,hi,C02,hi,C12,c12,lo,
			S3,lo,hi,lo,hi,lo,dif3);
    S4: logico port map(hi,lo,hi,C04,hi,C14,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c3,lo,hi,lo,hi,lo,dif4);
    S5: logico port map(c3,lo,hi,lo,hi,lo,
			c04,lo,hi,C04,hi,C14,c14,lo,
			S5,lo,hi,lo,hi,lo,dif5);
    S6: logico port map(c3,lo,hi,lo,hi,lo,
			ya,lo,hi,ya,yb,lo,hi,yb,
			hi,C06,hi,C16,hi,lo,dif6);
    S7: logico port map(ya,lo,hi,lo,hi,lo,
			yc,lo,yd,lo,yd,lo,yd,lo,
			c3,lo,yb,lo,hi,lo,dif7);

    B1: buf port map (c1,c1x);

    X0S: logico port map(hi,B0,hi,lo,hi,lo,
			CI,lo,hi,CI,hi,CI,CI,lo,
			hi,A0,hi,lo,hi,lo,dif0);
    X0C: logico port map(hi,B0,hi,lo,hi,lo,
			CI,lo,hi,lo,lo,hi,CI,lo,
			hi,A0,hi,lo,hi,lo,C0);
    X1: palcell port map(lo,
			C0,lo,hi,lo,hi,lo,
			hi,B1,hi,lo,lo,hi,hi,B1,
			A1,lo,hi,lo,hi,lo,
			lo,lo,open,C1,open,open,A1T);
    X2: palcell port map(lo,
			A2,B2,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B2,A2,hi,lo,hi,lo,
			lo,lo,C02,S2,open,open,C12);
    X3: palcell port map(lo,
			A3,B3,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B3,A3,hi,lo,hi,lo,
			lo,lo,C03,S3,open,open,C13);
    X5: palcell port map(lo,
			A5,B5,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B5,A5,hi,lo,hi,lo,
			lo,lo,C05,S5,open,open,C15);
    X7: palcell port map(lo,
			A7,B7,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B7,A7,hi,lo,hi,lo,
			lo,lo,C07,S7,open,open,C17);
    CO: logico port map(dif7,lo,hi,lo,hi,lo,
			lo,hi,b7,lo,b7,lo,hi,lo,
			hi,a7,hi,lo,hi,lo,co);

end archFBSUB8;

--
--	ADD16
--

use work.mathpkg.all;
ENTITY ADD16 IS
    PORT(CI,A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8,
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO : INOUT bit);
END ADD16;

ARCHITECTURE archADD16 OF ADD16 IS
BEGIN

   U0:fcadd16 port map
	(CI,A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0,
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8,
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0,CO);

END archADD16;

--
--	FCADD16
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity fcadd16 is
    PORT(CI,A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	    sum15,sum14,sum13,sum12,sum11,sum10,sum9,sum8,
	    sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,CO : INOUT bit);
end fcadd16;

architecture archFCADD16 of FCADD16 is

    signal lo,hi,c1x,c3x,c7x,a1t			: bit;
    signal c0,c1,s2,c02,c12,s3,c3,c03,c13		: bit;
    signal c04,c14,s5,c05,c15,c06,c16,s7,c7,c07,c17	: bit;
    signal c08,c18,s9,c09,c19,c0a,c1a,sb,c0b,c1b	: bit;
    signal c0c,c1c,sd,c0d,c1d,se,c0e,c1e,sf		: bit;
    signal ya,yb,yc,yd,ye,yf,yg,yh,yi,yj,yk,yl,ym,yn,yo	: bit;
    signal za,zb,zc,zd,ze,zf,zg,zh,zi,zj,zk,zl,zm,zn,zo	: bit;
    signal zex,zfx					: bit;
    signal uv,uw,ub					: bit;

begin
    lo <= '0';
    hi <= '1';

    MA: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			c05,lo,hi,c15,c05,lo,hi,c15,
			a4,lo,b4,lo,hi,lo,
			zero,zero,open,ya,open,za,c04);
    MB: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,c15,c05,lo,hi,c15,c05,lo,
			hi,lo,hi,a4,hi,b4,
			zero,zero,open,yb,open,zb,c14);
    MC: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s7,lo,hi,s7,c07,lo,hi,c17,
			a6,lo,b6,lo,hi,lo,
			zero,zero,open,yc,open,zc,c06);
    MD: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s7,s7,lo,hi,c17,c07,lo,
			hi,lo,hi,a6,hi,b6,
			zero,zero,open,yd,open,zd,c16);
    ME: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s9,lo,hi,s9,c09,lo,hi,c19,
			a8,lo,b8,lo,hi,lo,
			zero,zero,open,ye,open,ze,c08);
    MF: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s9,s9,lo,hi,c19,c09,lo,
			hi,lo,hi,a8,hi,b8,
			zero,zero,open,yf,open,zf,c18);
    MG: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			sb,lo,hi,sb,c0b,lo,hi,c1b,
			a10,lo,b10,lo,hi,lo,
			zero,zero,open,yg,open,zg,c0a);
    MH: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,sb,sb,lo,hi,c1b,c0b,lo,
			hi,lo,hi,a10,hi,b10,
			zero,zero,open,yh,open,zh,c1a);
    MI: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			sd,lo,hi,sd,c0d,lo,hi,c1d,
			a12,lo,b12,lo,hi,lo,
			zero,zero,open,yi,open,zi,c0c);
    MJ: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,sd,sd,lo,hi,c1d,c0d,lo,
			hi,lo,hi,a12,hi,b12,
			zero,zero,open,yj,open,zj,c1c);
    MK: palcell port map(lo,
			lo,lo,hi,lo,hi,lo,
			C0E,lo,hi,C0E,hi,C1E,C1E,lo,
			SF,lo,hi,lo,hi,lo,
			lo,lo,open,yk,open,zk,ub);
    ML: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			se,lo,hi,se,yk,lo,zk,lo,
			zi,lo,hi,lo,hi,lo,
			zero,zero,open,yl,open,zl,uv);
    MM: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			se,lo,hi,se,yk,lo,zk,lo,
			zj,lo,hi,lo,hi,lo,
			zero,zero,open,ym,open,zm,uw);
    MN: palcell port map(lo,
			lo,hi,lo,hi,lo,hi,
			yg,lo,yh,lo,zg,lo,zh,lo,
			ze,lo,hi,lo,hi,lo,
			lo,lo,open,yn,open,zn,zex);
    MO: palcell port map(lo,
			lo,hi,lo,hi,lo,hi,
			yg,lo,yh,lo,zg,lo,zh,lo,
			zf,lo,hi,lo,hi,lo,
			lo,lo,open,yo,open,zo,zfx);
    C3: palcell port map(lo,
			c02,lo,hi,lo,hi,lo,
			c03,lo,hi,c13,hi,c13,hi,c13,
			c1,c12,hi,lo,hi,lo,
			lo,lo,open,c3,open,open,open);
    C7: palcell port map(lo,
			za,lo,hi,lo,hi,lo,
			zc,lo,zd,lo,zd,lo,zd,lo,
			c3,lo,zb,lo,hi,lo,
			lo,lo,open,c7,open,open,open);
    D7: palcell port map(lo,
			za,lo,hi,lo,hi,lo,
			zc,lo,zd,lo,zd,lo,zd,lo,
			c3,lo,zb,lo,hi,lo,
			lo,lo,open,c7x,open,open,open);
    S1: logico port map(b1,lo,hi,lo,hi,lo,
			c0,lo,hi,C0,hi,C0,C0,lo,
			a1t,lo,hi,lo,hi,lo,sum1);
    S2: logico port map(c1x,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			S2,lo,hi,lo,hi,lo,sum2);
    S3: logico port map(c1x,lo,hi,lo,hi,lo,
			c02,lo,hi,C02,hi,C12,c12,lo,
			S3,lo,hi,lo,hi,lo,sum3);
    S4: logico port map(hi,lo,hi,C04,hi,C14,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c3x,lo,hi,lo,hi,lo,sum4);
    S5: logico port map(c3x,lo,hi,lo,hi,lo,
			c04,lo,hi,C04,hi,C14,c14,lo,
			S5,lo,hi,lo,hi,lo,sum5);
    S6: logico port map(c3x,lo,hi,lo,hi,lo,
			ya,lo,hi,ya,yb,lo,hi,yb,
			hi,C06,hi,C16,hi,lo,sum6);
    S7: logico port map(ya,lo,hi,lo,hi,lo,
			yc,lo,yd,lo,yd,lo,yd,lo,
			c3x,lo,yb,lo,hi,lo,sum7);
    S8: logico port map(hi,lo,hi,C08,hi,C18,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c7,lo,hi,lo,hi,lo,sum8);
    S9: logico port map(hi,lo,hi,lo,hi,lo,
			hi,lo,hi,lo,ye,lo,yf,lo,
			c7,lo,hi,lo,hi,lo,sum9);
    SA: logico port map(c7,lo,hi,lo,hi,lo,
			zex,lo,hi,zex,zfx,lo,hi,zfx,
			hi,C0A,hi,C1A,hi,lo,sum10);
    SB: logico port map(hi,lo,hi,lo,hi,lo,
			hi,lo,hi,lo,yn,lo,yo,lo,
			c7,lo,hi,lo,hi,lo,sum11);
    SC: logico port map(c7x,lo,hi,lo,hi,lo,
			zn,lo,hi,zn,zo,lo,hi,zo,
			hi,C0C,hi,C1C,hi,lo,sum12);
    SD: logico port map(zn,lo,hi,lo,hi,lo,
			yi,lo,yj,lo,yj,lo,yj,lo,
			c7x,lo,zo,lo,hi,lo,sum13);
    SE: logico port map(zn,lo,hi,lo,hi,lo,
			yl,lo,ym,lo,ym,lo,ym,lo,
			c7x,lo,zo,lo,hi,lo,sum14);
    SF: logico port map(zn,lo,hi,lo,hi,lo,
			zl,lo,zm,lo,zm,lo,zm,lo,
			c7x,lo,zo,lo,hi,lo,sum15);

    B1: buf port map (c1,c1x);
    B3: buf port map (c3,c3x);

    X0S: logico port map(hi,A0,hi,lo,hi,lo,
			CI,lo,hi,CI,hi,CI,CI,lo,
			hi,B0,hi,lo,hi,lo,sum0);
    X0C: logico port map(hi,A0,hi,lo,hi,lo,
			hi,lo,CI,lo,CI,lo,lo,hi,
			hi,B0,hi,lo,hi,lo,C0);
    X1: palcell port map(lo, 
			C0,lo,hi,lo,hi,lo,
			lo,hi,B1,lo,B1,lo,hi,lo,
			A1,lo,hi,lo,hi,lo,
			lo,lo,open,C1,open,open,A1T);
    X2: palcell port map(lo,
			A2,lo,B2,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A2,hi,B2,hi,lo,
			lo,lo,C02,S2,open,open,C12);
    X3: palcell port map(lo,
			A3,lo,B3,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A3,hi,B3,hi,lo,
			lo,lo,C03,S3,open,open,C13);
    X5: palcell port map(lo,
			A5,lo,B5,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A5,hi,B5,hi,lo,
			lo,lo,C05,S5,open,open,C15);
    X7: palcell port map(lo,
			A7,lo,B7,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A7,hi,B7,hi,lo,
			lo,lo,C07,S7,open,open,C17);
    X9: palcell port map(lo,
			A9,lo,B9,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A9,hi,B9,hi,lo,
			lo,lo,C09,S9,open,open,C19);
    XB: palcell port map(lo,
			A11,lo,B11,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A11,hi,B11,hi,lo,
			lo,lo,C0B,SB,open,open,C1B);
    XD: palcell port map(lo,
			A13,lo,B13,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A13,hi,B13,hi,lo,
			lo,lo,C0D,SD,open,open,C1D);
    XE: palcell port map(lo,
			A14,lo,B14,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A14,hi,B14,hi,lo,
			lo,lo,C0E,SE,open,open,C1E);
    XF: logico port map(A15,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			B15,lo,hi,lo,hi,lo,SF);
    CO: logico port map(a15,lo,hi,lo,hi,lo,
			lo,hi,b15,lo,b15,lo,hi,lo,
			hi,sum15,hi,lo,hi,lo,co);

end archFCADD16;

--
--	NCIADD16
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity nciadd16 is
    PORT(   A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	    sum15,sum14,sum13,sum12,sum11,sum10,sum9,sum8,
	    sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,CO : INOUT bit);
end nciadd16;

architecture archNCIADD16 of NCIADD16 is

    signal lo,hi,c1x,c3x,c7x,a1t			: bit;
    signal c0,c1,s2,c02,c12,s3,c3,c03,c13		: bit;
    signal c04,c14,s5,c05,c15,c06,c16,s7,c7,c07,c17	: bit;
    signal c08,c18,s9,c09,c19,c0a,c1a,sb,c0b,c1b	: bit;
    signal c0c,c1c,sd,c0d,c1d,se,c0e,c1e,sf		: bit;
    signal ya,yb,yc,yd,ye,yf,yg,yh,yi,yj,yk,yl,ym,yn,yo	: bit;
    signal za,zb,zc,zd,ze,zf,zg,zh,zi,zj,zk,zl,zm,zn,zo	: bit;
    signal zex,zfx					: bit;
    signal uv,uw,ub					: bit;

begin
    lo <= '0';
    hi <= '1';

    MA: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			c05,lo,hi,c15,c05,lo,hi,c15,
			a4,lo,b4,lo,hi,lo,
			zero,zero,open,ya,open,za,c04);
    MB: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,c15,c05,lo,hi,c15,c05,lo,
			hi,lo,hi,a4,hi,b4,
			zero,zero,open,yb,open,zb,c14);
    MC: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s7,lo,hi,s7,c07,lo,hi,c17,
			a6,lo,b6,lo,hi,lo,
			zero,zero,open,yc,open,zc,c06);
    MD: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s7,s7,lo,hi,c17,c07,lo,
			hi,lo,hi,a6,hi,b6,
			zero,zero,open,yd,open,zd,c16);
    ME: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s9,lo,hi,s9,c09,lo,hi,c19,
			a8,lo,b8,lo,hi,lo,
			zero,zero,open,ye,open,ze,c08);
    MF: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s9,s9,lo,hi,c19,c09,lo,
			hi,lo,hi,a8,hi,b8,
			zero,zero,open,yf,open,zf,c18);
    MG: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			sb,lo,hi,sb,c0b,lo,hi,c1b,
			a10,lo,b10,lo,hi,lo,
			zero,zero,open,yg,open,zg,c0a);
    MH: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,sb,sb,lo,hi,c1b,c0b,lo,
			hi,lo,hi,a10,hi,b10,
			zero,zero,open,yh,open,zh,c1a);
    MI: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			sd,lo,hi,sd,c0d,lo,hi,c1d,
			a12,lo,b12,lo,hi,lo,
			zero,zero,open,yi,open,zi,c0c);
    MJ: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,sd,sd,lo,hi,c1d,c0d,lo,
			hi,lo,hi,a12,hi,b12,
			zero,zero,open,yj,open,zj,c1c);
    MK: palcell port map(lo,
			lo,lo,hi,lo,hi,lo,
			C0E,lo,hi,C0E,hi,C1E,C1E,lo,
			SF,lo,hi,lo,hi,lo,
			lo,lo,open,yk,open,zk,ub);
    ML: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			se,lo,hi,se,yk,lo,zk,lo,
			zi,lo,hi,lo,hi,lo,
			zero,zero,open,yl,open,zl,uv);
    MM: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			se,lo,hi,se,yk,lo,zk,lo,
			zj,lo,hi,lo,hi,lo,
			zero,zero,open,ym,open,zm,uw);
    MN: palcell port map(lo,
			lo,hi,lo,hi,lo,hi,
			yg,lo,yh,lo,zg,lo,zh,lo,
			ze,lo,hi,lo,hi,lo,
			lo,lo,open,yn,open,zn,zex);
    MO: palcell port map(lo,
			lo,hi,lo,hi,lo,hi,
			yg,lo,yh,lo,zg,lo,zh,lo,
			zf,lo,hi,lo,hi,lo,
			lo,lo,open,yo,open,zo,zfx);
    C3: palcell port map(lo,
			c02,lo,hi,lo,hi,lo,
			c03,lo,hi,c13,hi,c13,hi,c13,
			c1,c12,hi,lo,hi,lo,
			lo,lo,open,c3,open,open,open);
    C7: palcell port map(lo,
			za,lo,hi,lo,hi,lo,
			zc,lo,zd,lo,zd,lo,zd,lo,
			c3,lo,zb,lo,hi,lo,
			lo,lo,open,c7,open,open,open);
    D7: palcell port map(lo,
			za,lo,hi,lo,hi,lo,
			zc,lo,zd,lo,zd,lo,zd,lo,
			c3,lo,zb,lo,hi,lo,
			lo,lo,open,c7x,open,open,open);
    S1: logico port map(b1,lo,hi,lo,hi,lo,
			c0,lo,hi,C0,hi,C0,C0,lo,
			a1t,lo,hi,lo,hi,lo,sum1);
    S2: logico port map(c1x,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			S2,lo,hi,lo,hi,lo,sum2);
    S3: logico port map(c1x,lo,hi,lo,hi,lo,
			c02,lo,hi,C02,hi,C12,c12,lo,
			S3,lo,hi,lo,hi,lo,sum3);
    S4: logico port map(hi,lo,hi,C04,hi,C14,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c3x,lo,hi,lo,hi,lo,sum4);
    S5: logico port map(c3x,lo,hi,lo,hi,lo,
			c04,lo,hi,C04,hi,C14,c14,lo,
			S5,lo,hi,lo,hi,lo,sum5);
    S6: logico port map(c3x,lo,hi,lo,hi,lo,
			ya,lo,hi,ya,yb,lo,hi,yb,
			hi,C06,hi,C16,hi,lo,sum6);
    S7: logico port map(ya,lo,hi,lo,hi,lo,
			yc,lo,yd,lo,yd,lo,yd,lo,
			c3x,lo,yb,lo,hi,lo,sum7);
    S8: logico port map(hi,lo,hi,C08,hi,C18,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c7,lo,hi,lo,hi,lo,sum8);
    S9: logico port map(hi,lo,hi,lo,hi,lo,
			hi,lo,hi,lo,ye,lo,yf,lo,
			c7,lo,hi,lo,hi,lo,sum9);
    SA: logico port map(c7,lo,hi,lo,hi,lo,
			zex,lo,hi,zex,zfx,lo,hi,zfx,
			hi,C0A,hi,C1A,hi,lo,sum10);
    SB: logico port map(hi,lo,hi,lo,hi,lo,
			hi,lo,hi,lo,yn,lo,yo,lo,
			c7,lo,hi,lo,hi,lo,sum11);
    SC: logico port map(c7x,lo,hi,lo,hi,lo,
			zn,lo,hi,zn,zo,lo,hi,zo,
			hi,C0C,hi,C1C,hi,lo,sum12);
    SD: logico port map(zn,lo,hi,lo,hi,lo,
			yi,lo,yj,lo,yj,lo,yj,lo,
			c7x,lo,zo,lo,hi,lo,sum13);
    SE: logico port map(zn,lo,hi,lo,hi,lo,
			yl,lo,ym,lo,ym,lo,ym,lo,
			c7x,lo,zo,lo,hi,lo,sum14);
    SF: logico port map(zn,lo,hi,lo,hi,lo,
			zl,lo,zm,lo,zm,lo,zm,lo,
			c7x,lo,zo,lo,hi,lo,sum15);

    B1: buf port map (c1,c1x);
    B3: buf port map (c3,c3x);

    X0: logico port map(hi,A0,hi,B0,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			C0,lo,hi,lo,hi,lo,sum0);
    X1: palcell port map(lo, 
			A0,lo,B0,lo,hi,lo,
			lo,hi,B1,lo,B1,lo,hi,lo,
			A1,lo,hi,lo,hi,lo,
			lo,lo,C0,C1,open,open,A1T);
    X2: palcell port map(lo,
			A2,lo,B2,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A2,hi,B2,hi,lo,
			lo,lo,C02,S2,open,open,C12);
    X3: palcell port map(lo,
			A3,lo,B3,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A3,hi,B3,hi,lo,
			lo,lo,C03,S3,open,open,C13);
    X5: palcell port map(lo,
			A5,lo,B5,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A5,hi,B5,hi,lo,
			lo,lo,C05,S5,open,open,C15);
    X7: palcell port map(lo,
			A7,lo,B7,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A7,hi,B7,hi,lo,
			lo,lo,C07,S7,open,open,C17);
    X9: palcell port map(lo,
			A9,lo,B9,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A9,hi,B9,hi,lo,
			lo,lo,C09,S9,open,open,C19);
    XB: palcell port map(lo,
			A11,lo,B11,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A11,hi,B11,hi,lo,
			lo,lo,C0B,SB,open,open,C1B);
    XD: palcell port map(lo,
			A13,lo,B13,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A13,hi,B13,hi,lo,
			lo,lo,C0D,SD,open,open,C1D);
    XE: palcell port map(lo,
			A14,lo,B14,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			hi,A14,hi,B14,hi,lo,
			lo,lo,C0E,SE,open,open,C1E);
    XF: logico port map(A15,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			B15,lo,hi,lo,hi,lo,SF);
    CO: logico port map(a15,lo,hi,lo,hi,lo,
			lo,hi,b15,lo,b15,lo,hi,lo,
			hi,sum15,hi,lo,hi,lo,co);

end archNCIADD16;

--
--	FBSUB16
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity FBSUB16 is
    PORT(CI,A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0,
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN bit;
	    dif15,dif14,dif13,dif12,dif11,dif10,dif9,dif8,
	    dif7,dif6,dif5,dif4,dif3,dif2,dif1,dif0,CO : INOUT bit);
end FBSUB16;

architecture archFBSUB16 of FBSUB16 is

    signal lo,hi,c1x,c3x,c7x,a1t			: bit;
    signal c0,c1,s2,c02,c12,s3,c3,c03,c13		: bit;
    signal c04,c14,s5,c05,c15,c06,c16,s7,c7,c07,c17	: bit;
    signal c08,c18,s9,c09,c19,c0a,c1a,sb,c0b,c1b	: bit;
    signal c0c,c1c,sd,c0d,c1d,se,c0e,c1e,sf		: bit;
    signal ya,yb,yc,yd,ye,yf,yg,yh,yi,yj,yk,yl,ym,yn,yo	: bit;
    signal za,zb,zc,zd,ze,zf,zg,zh,zi,zj,zk,zl,zm,zn,zo	: bit;
    signal zex,zfx					: bit;
    signal uv,uw,ub					: bit;

begin
    lo <= '0';
    hi <= '1';

    MA: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			c05,lo,hi,c15,c05,lo,hi,c15,
			a4,b4,hi,lo,hi,lo,
			zero,zero,open,ya,open,za,c04);
    MB: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,c15,c05,lo,hi,c15,c05,lo,
			hi,lo,hi,a4,b4,lo,
			zero,zero,open,yb,open,zb,c14);
    MC: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s7,lo,hi,s7,c07,lo,hi,c17,
			a6,b6,hi,lo,hi,lo,
			zero,zero,open,yc,open,zc,c06);
    MD: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s7,s7,lo,hi,c17,c07,lo,
			hi,lo,hi,a6,b6,lo,
			zero,zero,open,yd,open,zd,c16);
    ME: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			s9,lo,hi,s9,c09,lo,hi,c19,
			a8,b8,hi,lo,hi,lo,
			zero,zero,open,ye,open,ze,c08);
    MF: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,s9,s9,lo,hi,c19,c09,lo,
			hi,lo,hi,a8,b8,lo,
			zero,zero,open,yf,open,zf,c18);
    MG: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			sb,lo,hi,sb,c0b,lo,hi,c1b,
			a10,b10,hi,lo,hi,lo,
			zero,zero,open,yg,open,zg,c0a);
    MH: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,sb,sb,lo,hi,c1b,c0b,lo,
			hi,lo,hi,a10,b10,lo,
			zero,zero,open,yh,open,zh,c1a);
    MI: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			sd,lo,hi,sd,c0d,lo,hi,c1d,
			a12,b12,hi,lo,hi,lo,
			zero,zero,open,yi,open,zi,c0c);
    MJ: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			hi,sd,sd,lo,hi,c1d,c0d,lo,
			hi,lo,hi,a12,b12,lo,
			zero,zero,open,yj,open,zj,c1c);
    MK: palcell port map(lo,
			lo,lo,hi,lo,hi,lo,
			C0E,lo,hi,C0E,hi,C1E,C1E,lo,
			SF,lo,hi,lo,hi,lo,
			lo,lo,open,yk,open,zk,ub);
    ML: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			se,lo,hi,se,yk,lo,zk,lo,
			zi,lo,hi,lo,hi,lo,
			zero,zero,open,yl,open,zl,uv);
    MM: palcell port map(zero,
			lo,zero,one,zero,one,zero,
			se,lo,hi,se,yk,lo,zk,lo,
			zj,lo,hi,lo,hi,lo,
			zero,zero,open,ym,open,zm,uw);
    MN: palcell port map(lo,
			lo,hi,lo,hi,lo,hi,
			yg,lo,yh,lo,zg,lo,zh,lo,
			ze,lo,hi,lo,hi,lo,
			lo,lo,open,yn,open,zn,zex);
    MO: palcell port map(lo,
			lo,hi,lo,hi,lo,hi,
			yg,lo,yh,lo,zg,lo,zh,lo,
			zf,lo,hi,lo,hi,lo,
			lo,lo,open,yo,open,zo,zfx);
    C3: palcell port map(lo,
			c02,lo,hi,lo,hi,lo,
			c03,lo,hi,c13,hi,c13,hi,c13,
			c1,c12,hi,lo,hi,lo,
			lo,lo,open,c3,open,open,open);
    C7: palcell port map(lo,
			za,lo,hi,lo,hi,lo,
			zc,lo,zd,lo,zd,lo,zd,lo,
			c3,lo,zb,lo,hi,lo,
			lo,lo,open,c7,open,open,open);
    D7: palcell port map(lo,
			za,lo,hi,lo,hi,lo,
			zc,lo,zd,lo,zd,lo,zd,lo,
			c3,lo,zb,lo,hi,lo,
			lo,lo,open,c7x,open,open,open);
    S1: logico port map(b1,lo,hi,lo,hi,lo,
			c0,lo,hi,C0,hi,C0,C0,lo,
			a1t,lo,hi,lo,hi,lo,dif1);
    S2: logico port map(c1x,lo,hi,lo,hi,lo,
			lo,hi,hi,lo,hi,lo,lo,hi,
			S2,lo,hi,lo,hi,lo,dif2);
    S3: logico port map(c1x,lo,hi,lo,hi,lo,
			c02,lo,hi,C02,hi,C12,c12,lo,
			S3,lo,hi,lo,hi,lo,dif3);
    S4: logico port map(hi,lo,hi,C04,hi,C14,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c3x,lo,hi,lo,hi,lo,dif4);
    S5: logico port map(c3x,lo,hi,lo,hi,lo,
			c04,lo,hi,C04,hi,C14,c14,lo,
			S5,lo,hi,lo,hi,lo,dif5);
    S6: logico port map(c3x,lo,hi,lo,hi,lo,
			ya,lo,hi,ya,yb,lo,hi,yb,
			hi,C06,hi,C16,hi,lo,dif6);
    S7: logico port map(ya,lo,hi,lo,hi,lo,
			yc,lo,yd,lo,yd,lo,yd,lo,
			c3x,lo,yb,lo,hi,lo,dif7);
    S8: logico port map(hi,lo,hi,C08,hi,C18,
			lo,hi,hi,lo,hi,lo,lo,hi,
			c7,lo,hi,lo,hi,lo,dif8);
    S9: logico port map(hi,lo,hi,lo,hi,lo,
			hi,lo,hi,lo,ye,lo,yf,lo,
			c7,lo,hi,lo,hi,lo,dif9);
    SA: logico port map(c7,lo,hi,lo,hi,lo,
			zex,lo,hi,zex,zfx,lo,hi,zfx,
			hi,C0A,hi,C1A,hi,lo,dif10);
    SB: logico port map(hi,lo,hi,lo,hi,lo,
			hi,lo,hi,lo,yn,lo,yo,lo,
			c7,lo,hi,lo,hi,lo,dif11);
    SC: logico port map(c7x,lo,hi,lo,hi,lo,
			zn,lo,hi,zn,zo,lo,hi,zo,
			hi,C0C,hi,C1C,hi,lo,dif12);
    SD: logico port map(zn,lo,hi,lo,hi,lo,
			yi,lo,yj,lo,yj,lo,yj,lo,
			c7x,lo,zo,lo,hi,lo,dif13);
    SE: logico port map(zn,lo,hi,lo,hi,lo,
			yl,lo,ym,lo,ym,lo,ym,lo,
			c7x,lo,zo,lo,hi,lo,dif14);
    SF: logico port map(zn,lo,hi,lo,hi,lo,
			zl,lo,zm,lo,zm,lo,zm,lo,
			c7x,lo,zo,lo,hi,lo,dif15);

    B1: buf port map (c1,c1x);
    B3: buf port map (c3,c3x);

    X0S: logico port map(hi,B0,hi,lo,hi,lo,
			CI,lo,hi,CI,hi,CI,CI,lo,
			hi,A0,hi,lo,hi,lo,dif0);
    X0C: logico port map(hi,B0,hi,lo,hi,lo,
			CI,lo,hi,lo,lo,hi,CI,lo,
			hi,A0,hi,lo,hi,lo,C0);
    X1: palcell port map(lo, 
			C0,lo,hi,lo,hi,lo,
			hi,B1,hi,lo,lo,hi,hi,B1,
			A1,lo,hi,lo,hi,lo,
			lo,lo,open,C1,open,open,A1T);
    X2: palcell port map(lo,
			A2,B2,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B2,A2,hi,lo,hi,lo,
			lo,lo,C02,S2,open,open,C12);
    X3: palcell port map(lo,
			A3,B3,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B3,A3,hi,lo,hi,lo,
			lo,lo,C03,S3,open,open,C13);
    X5: palcell port map(lo,
			A5,B5,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B5,A5,hi,lo,hi,lo,
			lo,lo,C05,S5,open,open,C15);
    X7: palcell port map(lo,
			A7,B7,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B7,A7,hi,lo,hi,lo,
			lo,lo,C07,S7,open,open,C17);
    X9: palcell port map(lo,
			A9,B9,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B9,A9,hi,lo,hi,lo,
			lo,lo,C09,S9,open,open,C19);
    XB: palcell port map(lo,
			A11,B11,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B11,A11,hi,lo,hi,lo,
			lo,lo,C0B,SB,open,open,C1B);
    XD: palcell port map(lo,
			A13,B13,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B13,A13,hi,lo,hi,lo,
			lo,lo,C0D,SD,open,open,C1D);
    XE: palcell port map(lo,
			A14,B14,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,lo,hi,
			B14,A14,hi,lo,hi,lo,
			lo,lo,C0E,SE,open,open,C1E);
    XF: logico port map(A15,lo,hi,lo,hi,lo,
			hi,lo,lo,hi,lo,hi,hi,lo,
			B15,lo,hi,lo,hi,lo,SF);
    CO: logico port map(dif15,lo,hi,lo,hi,lo,
			lo,hi,b15,lo,b15,lo,hi,lo,
			hi,A15,hi,lo,hi,lo,co);

end archFBSUB16;

--
--	MULT4X4
--

use work.cypress.all; 
use work.mathpkg_local.all; 

entity MULT4X4 is
    port(B3,B2,B1,B0,M3,M2,M1,M0: IN bit;
	 Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0: INOUT bit);
end MULT4X4;

architecture archMULT4X4 of MULT4X4 is

    signal N1, N2, N3, N4, N5, N6, N7, N8 : bit;
    signal N9, N10, N11, N12, N13, N14, N15, N16 : bit;
    
begin
    S1: logico port map(N10,zero,one,zero,one,zero,
			zero,one,N7,zero,N7,zero,one,zero,
			M0,zero,B2,zero,one,zero,
			N8);

    S2: logico port map(N10,zero,one,zero,one,zero,
			N7,zero,one,N7,one,N7,N7,zero,
			M0,zero,B2,zero,one,zero,
			Q2);

    S3: logico port map(N9,zero,one,zero,one,zero,
			zero,one,N4,zero,N4,zero,one,zero,
			M1,zero,B2,zero,one,zero,
			N5);

    S4: logico port map(N9,zero,one,zero,one,zero,
			N4,zero,one,N4,one,N4,N4,zero,
			M1,zero,B2,zero,one,zero,
			N12);

    S5: logico port map(N11,zero,one,zero,one,zero,
			zero,one,N5,zero,N5,zero,one,zero,
			M1,zero,B3,zero,one,zero,
			N6);

    S6: logico port map(N11,zero,one,zero,one,zero,
			N5,zero,one,N5,one,N5,N5,zero,
			M1,zero,B3,zero,one,zero,
			N14);

    S7: logico port map(N12,zero,one,zero,one,zero,
			zero,one,N8,zero,N8,zero,one,zero,
			M0,zero,B3,zero,one,zero,
			N16);

    S8: logico port map(N12,zero,one,zero,one,zero,
			N8,zero,one,N8,one,N8,N8,zero,
			M0,zero,B3,zero,one,zero,
			Q3);

    S9: logico port map(N13,zero,one,zero,one,zero,
			zero,one,N6,zero,N6,zero,one,zero,
			N14,zero,N16,zero,one,zero,
			N15);

    SA: logico port map(N13,zero,one,zero,one,zero,
			N6,zero,one,N6,one,N6,N6,zero,
			N14,zero,N16,zero,one,zero,
			Q5);

    SB: logico port map(M3,zero,B3,zero,one,zero,
			N3,zero,one,N3,one,N3,N3,zero,
			N15,zero,one,zero,one,zero,
			Q6);

    SC: logico port map(M3,zero,B3,zero,one,zero,
			zero,one,N3,zero,N3,zero,one,zero,
			N15,zero,one,zero,one,zero,
			Q7);

    SD: logico port map(M1,zero,B0,zero,one,zero,
			zero,one,zero,one,zero,one,one,zero,
			M0,zero,B1,zero,one,zero,
			N7);

    SE: logico port map(M1,zero,B0,zero,one,zero,
			zero,one,one,zero,one,zero,zero,one,
			M0,zero,B1,zero,one,zero,
			Q1);

    SF: logico port map(M2,zero,B0,zero,one,zero,
			zero,one,zero,one,zero,one,one,zero,
			M1,zero,B1,zero,one,zero,
			N4);

    SG: logico port map(M2,zero,B0,zero,one,zero,
			zero,one,one,zero,one,zero,zero,one,
			M1,zero,B1,zero,one,zero,
			N10);

    SH: logico port map(M3,zero,B0,zero,one,zero,
			zero,one,zero,one,zero,one,one,zero,
			M2,zero,B1,zero,one,zero,
			N1);

    SI: logico port map(M3,zero,B0,zero,one,zero,
			zero,one,one,zero,one,zero,zero,one,
			M2,zero,B1,zero,one,zero,
			N9);

    SJ: logico port map(M3,zero,B1,zero,one,zero,
			zero,one,N1,zero,N1,zero,one,zero,
			M2,zero,B2,zero,one,zero,
			N2);

    SK: logico port map(M3,zero,B1,zero,one,zero,
			N1,zero,one,N1,one,N1,N1,zero,
			M2,zero,B2,zero,one,zero,
			N11);

    SL: logico port map(M3,zero,B2,zero,one,zero,
			zero,one,N2,zero,N2,zero,one,zero,
			M2,zero,B3,zero,one,zero,
			N3);

    SM: logico port map(M3,zero,B2,zero,one,zero,
			N2,zero,one,N2,one,N2,N2,zero,
			M2,zero,B3,zero,one,zero,
			N13);

    SN: logico port map(one,zero,one,zero,one,zero,
			one,zero,one,zero,N16,zero,one,N16,
			N14,zero,one,zero,one,zero,
			Q4);

    SO: PAFRAG_A port map(M0,zero,B0,zero,one,zero,Q0);

end archMULT4X4;

--
--	COMPare BIT 2
--

use work.cypress.all;
use work.mathpkg_local.all;

entity COMPBIT2 is
    PORT (
	A0,B0,A1,B1			: IN	BIT;
	EQ0,EQ1				: INOUT	BIT);
    attribute dont_touch of compbit2 : entity is true;
END COMPBIT2;

architecture archCOMPBIT2 of COMPBIT2 is

begin

    U1:palcell port map(zero,A0,zero,one,zero,one,B0,
			B0,A0,B0,A0,one,A1,A1,zero,
			B1,zero,one,zero,one,zero,
			zero,zero,open,EQ0,open,EQ1,open);

end archCOMPBIT2;

--
--	EQual COMPare 4
--

use work.cypress.all;
use work.mathpkg_local.all;

entity EQCOMP4 is
	PORT (A3,A2,A1,A0,B3,B2,B1,B0 : IN BIT;
	    EQ	: INOUT	BIT);
end EQCOMP4;

architecture archEQCOMP4 of EQCOMP4 is

	signal e3,e2,e1,e0:	bit;

begin
	U0: compbit2 port map (a0,b0,a1,b1,e0,e1);
	U2: compbit2 port map (a2,b2,a3,b3,e2,e3);

	f1: pafrag_a port map (e3,e2,e1,e0,one,zero,eq);

end archEQCOMP4;

--
--	EQual COMPare 8
--

use work.cypress.all;
use work.mathpkg_local.all;

entity EQCOMP8 is
	PORT (A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: INOUT	BIT);
end EQCOMP8;

architecture archEQCOMP8 of EQCOMP8 is

	signal e7,e6,e5,e4,e3,e2,e1,e0	: bit;

begin
	U0: compbit2 port map (a0,b0,a1,b1,e0,e1);
	U2: compbit2 port map (a2,b2,a3,b3,e2,e3);
	U4: compbit2 port map (a4,b4,a5,b5,e4,e5);
	U6: compbit2 port map (a6,b6,a7,b7,e6,e7);

	U1:logico port map(e7,e6,e5,e4,one,zero,
			   zero,one,zero,one,zero,one,one,zero,
			   e3,e2,e1,e0,one,zero,eq);

end archEQCOMP8;

--
--	EQual COMPare 16
--

use work.cypress.all;
use work.mathpkg_local.all;

entity EQCOMP16 is
	PORT (A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0 : IN BIT;
	      B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: INOUT	BIT);
end EQCOMP16;

architecture archEQCOMP16 of EQCOMP16 is

	signal ef,ee,ed,ec,eb,ea,e9,e8,e7,e6,e5,e4,e3,e2,e1,e0,mz : bit;

begin
	U0: compbit2 port map (a0,b0,a1,b1,e0,e1);
	U2: compbit2 port map (a2,b2,a3,b3,e2,e3);
	U4: compbit2 port map (a4,b4,a5,b5,e4,e5);
	U6: compbit2 port map (a6,b6,a7,b7,e6,e7);
	U8: compbit2 port map (a8,b8,a9,b9,e8,e9);
	Ua: compbit2 port map (a10,b10,a11,b11,ea,eb);
	Uc: compbit2 port map (a12,b12,a13,b13,ec,ed);
	Ue: compbit2 port map (a14,b14,a15,b15,ee,ef);

	f1:pafrag_a port map (e9,e8,e7,e6,e5,e4,mz);
	U1:logico port map(ef,ee,ed,ec,eb,ea,
			   zero,one,zero,one,zero,one,mz,zero,
			   e3,e2,e1,e0,one,zero,eq);

end archEQCOMP16;
