--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

library ieee;
use ieee.std_logic_1164.all;

PACKAGE c16v8p IS			-- C16V8 Specific package.
    
    TYPE reg_def  IS (reg, comb);	-- Noreg generic.
    TYPE polarity IS (invt, ninv);	-- Port polarity.
    TYPE fb_type  IS (xpin, xreg, xadj);-- feedback type.

    COMPONENT c16v8m			-- Device C16V8 macro cell.
	GENERIC (
	    registered	: reg_def	:= reg;  -- Default is REGistered.
	    inv_setting	: polarity	:= invt; -- Default is INVerTed.
	    bta_sel	: fb_type	:= xreg; -- Default is Registered.
	    Tpd		: TIME		:= 10 ns;
	    Ten		: TIME		:= 10 ns;
	    Tdis	: TIME		:= 10 ns;
	    Tco		: TIME		:=  7 ns;
	    Tsu		: TIME		:=  7 ns;
	    Th		: TIME		:=  0 ns;
	    Twh		: TIME		:=  8 ns;
	    Twl		: TIME		:=  8 ns;
	    Tcf		: TIME		:=  6 ns);
	PORT (
	    d	: IN	std_logic;	-- D input to register.
	    clk	: IN	std_logic;	-- Positive Edge Clock.
	    oe	: IN	std_logic;	-- Output Enable.
	    adj	: IN	std_logic;	-- Adjacent cell feedback.
	    y	: INOUT	std_logic;	-- IO pin.
	    fb	: OUT	std_logic;	-- signal to Array.
	    yfb	: OUT	std_logic);	-- signal to adjacent cell.
    END COMPONENT;
	
END c16v8p;
